﻿#target InDesign;
#targetengine "sessionGrep";
//DESCRIPTION: Highlight GREP matches 

/*     
    + Indesign Version: 8.0
    + Autor: Roland Dreger
    + Datum: 24. January 2014
    
    + Please notice: Locked layers and objects are not searched.
    
    + Hint: At running the script a new condition (Conditional Text) is created. 
      It's called "::Highlight_GREP::". The script applied them to GREP expressions matches. 
      After completion of the script, the condition is normally removed.

      If, for whatever reason, the condition is still existing after using the script, 
      you could open the Conditional Text panel (Window > Type and Tables > Conditional Text) 
      and delete it.

      
      
    + Thanks to Peter Kahrel (www.kahrel.plus.com) for his idea to use conditional text for highlighting. 
*/


// Globals 
var _highlightColor = [255,150,0]; // Color of highlighting in [R,G,B] (the color can be changed in the Conditional Text panel)
var _highlightMethod = ConditionIndicatorMethod.USE_HIGHLIGHT; // "USE_UNDERLINE" for Highlighting by underlining

var _alertCounter = false; // Warning conditional text
if (app.documents.length > 0) { var _currentDoc = app.activeDocument.getElements()[0]; } // Warning conditional text
var _lastDoc = _currentDoc; // Warning conditional text



if (app.documents.length > 0) { 	
  app.doScript(main, ScriptLanguage.JAVASCRIPT , [], UndoModes.ENTIRE_SCRIPT, "Highlight GREP");  
} else {
  alert ("No document opened!\rTo run the script at least one document must be open.");
}



function main () {
  
  app.scriptPreferences.enableRedraw = true;
  prototypeItemByLabel ();
  var _ui = _highlightPalette ();
  
  _ui.show(); 
}


function _highlightPalette () {
  
  var _doc = app.activeDocument;
  var _hits = 0; // Number of matches
  var _sc = 0; // Counter for selection
  var _filePath = filePath ();
  var _palette = Window.find("palette", "Highlight GREP Results", undefined, {borderless: false, closeButton: true}); /* refresh UI */
   
  if (_palette==null) {  /* refresh UI */   
    _palette = new Window ("palette", "Highlight GREP Results");
    with (_palette) {     
      orientation = "row";
      margins = 10;
      spacing = 0;
      var _columnLeft = add ("group");
      with (_columnLeft) {
        orientation = "column";
        alignment = ["", "fill"];
        alignChildren = ["left","fill"];
        margins = [5,30,15,11];
        var _hitsGroup = add ("group");
        with (_hitsGroup) {
          orientation = "column";
          alignChildren = "left";
          spacing = 0;
          margins.right = 0;
          var _numberOfHits = add ("statictext", undefined, "0");
          with (_numberOfHits) {
            characters = 6;
            graphics.font = "dialog:32";
            if(app.scriptPreferences.version < 9) {
              graphics.foregroundColor = graphics.newPen (graphics.PenType.SOLID_COLOR, [0.2, 0.2, 0.2], 1);
            }
            helpTip = "Number of matches";
          } // END statictext _numberOfHits         
          var _hitsButtonGroup = add ("group");
          with (_hitsButtonGroup) {
            margins.top = 10;
            spacing = 10;
            margins.left = 0;
            try {
              if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                var _selectionButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00A6IDATx\u00DAbliia\u00A06`\x01b999*\u009A(  \u00C0\u00C4@\x030\u00C2\re\u00C1#7k\u00D6,<\u00B2iii\u00C3\u00DB\u00FBx<H\x1D\u0097\x1E8p\u00E0\u00D6\u00AD[Tp)\u009A\u0089\x10C\u00D5\u00D4\u00D4\u00A8\u00E0Rd7\x12\u00E9^&R}M\u008C\u00B9Ld\u0084#As\u0099\u00C8\u008B\x19\u00FC\u00B2Ld\u00C75\x1E5\u00D8c\u00DF\x01\fpeV\u0082\u00E9wxdS\u00B23+aC\u00C9\b\u00D3\x01r\u00E9\u00D1\u00A3G\u00D1D\u00AC\u00AD\u00AD)5\u0094\u00A0\x11\u00E4\x18\u00FA\u00F4\u00E9S4\x11iiiJ\r%h\x04vC\u0081m\n\u00EA\u00A6S\u0080\x00\x03\x00\"\u00B9TX!\"\u0086g\x00\x00\x00\x00IEND\u00AEB`\u0082";
              } else {
                var _selectionButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00ACIDATx\u00DAb<{\u00F6,\x03\u00B5\x01\x0B\x10\u008B\u0088\u0088P\u00D1DQQQ&\x06\x1A\u0080\x11n(\x0B\x1E\u00B9\u0092\u0092\x12<\u00B2===C\u00DF\u00FB\u008C\u00C0\u00C4?`\u00E9t\u00C5\u008A\x15\u00A7O\u009F\u00A6BD!\u009Bx\x06\f\u0080lSSS*\u0084)\u00C4D\b{\u00E5\u00CA\u0095\u00C4\u00B8\u0097\u0089x\x13\u00897\u0097\u0089$\x13\u00894\u0097\u0089T\x13\u00891\u0097\u0089\f\x13\t\u009AK8\u009DbfV<\x19t\u00A8\u0095\u00A74\u00C9\u00A6\u0084s\x14\u00A9a:p.]\u00B7n\x1D\u009AHPP\x10\u00A5\x05\nA#\u00C81\u00F4\u00F6\u00ED\u00DBh\"\u00AA\u00AA\u00AA\u0094\x1AJ\u00D0\b\u00EC\u0086\x02\u0083\u0096\u00BA\u00E9\x14 \u00C0\x00Z\u00C6V\u00A4\u00F1\u00AE\u0090\u00B5\x00\x00\x00\x00IEND\u00AEB`\u0082";
              } 
              var _selectionButton = add ("iconbutton", undefined, _selectionButtonIcon, {style: "toolbutton"});
              with (_selectionButton) {
                size = [28,28];
                helpTip = "Select match(es)";
              } // END iconbutton _selectionButtonIcon
            } catch (e) {
              var _selectionButton = add ("button", undefined, "S");
              with (_selectionButton) {
                preferredSize.height = 23;
                preferredSize.width = 23;
                graphics.font = "dialog:11";
                helpTip = "Select match(es)";
              } // END button _selectionButton
            } // END selection icon                        
            try {
              if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                var _copyButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00AAIDATx\u00DAbliia\u00A06`\x01b999*\u009A(  \u00C0\u00C4@\x030t\fe!F\u00D1\u00DA\u00B5k\u00DF\u00BE}\x0Bd\b\x0B\x0B\x07\x07\x07S\u00C7P\u00A0\u0089iii@\u00C6\u00ACY\u00B3\u0088Q\u00CF\bLR\u0098\u00B1\x0F\u00D1\f4\b\u0097)p)\u0088e\u00F4\u0088}\x02\u00DE\u00C7t\u00C8`\u008D}x\u0098\u00A2\u0085/~\x1F\ft\u0098\x12\x1F\u00BE\u00C4z\u009F`J\x1AL\u00DE'>\x10\u0088\u00F2>f\u00D6\x1A\u00C4\u00DE')k\u00D1\u00DD\u00A5\x04\x0B:\x1E\x1E\x1E\x12\\jiiI\u00D09@\x13uuuIp\u00A9.\x18\u008C\u0080\u008A\u008Ff\u00B1\x0F\u00ACU\u00A8k(@\u0080\x01\x00\u0084\u00C98(\u00F7\x01l\u00A1\x00\x00\x00\x00IEND\u00AEB`\u0082";
                } else {
                var _copyButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00A6IDATx\u00DAb<{\u00F6,\x03\u00B5\x01\x0B\x10\u008B\u0088\u0088P\u00D1DQQQ&\x06\x1A\u0080\u00A1c(\x0B1\u008A\u00FA\u00FA\u00FA\u009E={\x06dHII\x15\x15\x15Q\u00C7P\u00A0\u0089===@FII\t1\u00EA\x19\u0081I\n3\u00F6!\u009A\u0081\x06\u00E12\x05.\x05\u00B1\u008C\x1E\u00B1O\u00C0\u00FB\u0098\x0E\x19\u00AC\u00B1\x0F\x0FS\u00B4\u00F0\u00C5\u00EF\u0083\u0081\x0ES\u00E2\u00C3\u0097X\u00EF\x13LI\u0083\u00C9\u00FB\u00C4\x07\x02Q\u00DE\u00C7\u00CCZ\u0083\u00D8\u00FB$e-\u00BA\u00BB\u0094`A'((H\u0082K\u00FD\u00FD\u00FD\t:\x07h\u00A2\u009D\u009D\x1D\t\u00E5\u00E9hmJi\u00EC\x03C\u0081\u00BA\u0086\x02\x04\x18\x00\u00CD\u00C1>\u00CA3\u00F0@\u00D7\x00\x00\x00\x00IEND\u00AEB`\u0082";
              }
              var _copyButton = add ("iconbutton", undefined, _copyButtonIcon, {style: "toolbutton"});
              with (_copyButton) {
                size = [28,28];
                helpTip = "Copy match(es) to clipboard";
              } // END iconbutton _copyButton
            } catch (e) {           
              var _copyButton = add ("button", undefined, "C");
              with (_copyButton) {
                preferredSize.height = 23;
                preferredSize.width = 23;
                graphics.font = "dialog:11";
                helpTip = "Copy match(es) to clipboard";
              } // END button _copyButton  
            } // END copy icon          
            try {
              if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                var _clearConditionButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u0095IDATx\u00DA\u00EC\u00961\u00AB\u0082P\x14\u00C7}\u008F\u00D0M\x1C\x1BJ$tj\u00D3\u00A9 R\x1A\u00EA\x1B4i\u0093\u00DF\u00C4o\u00E1$mmm:5\x04EC\u009B6EC\x10D\u00E3\u00DB\u00DC\u00DE\u009Fw\u00E1r\u00E9\u009Ae\u00AF\u00B6\x0Ex\u0088k\u00FC:\u00E7\x7F\u00CE_\u00FB\n\u0082@xu\u00D4p\u00A9\u00AA\u00FAB\u00A2\u00A2(\u00DF\u00C2\x1B\u00E2\x03\x15\u00DE2}>\u00A2(\x1A\x0E\u0087\u00F5z\u009D\u00BF\u0095e\u00D9j\u00B5\u00C2\x07\u00C30l\u00DB\u00AEPi\u00BF\u00DFO\u0092\u00E4|>\u00F3\u00C48\u008E\x7F\u00FEb\u00BB\u00DDN\u00A7\u00D3\nPM\u00D3x.\u0088\x00\u00B1\u00D5].\u0097\u00C5bQAS\u009E\x0B\u00E2x<\u00B6,k4\x1A\u00D1\u00AF\u00ED\u00F7\u00FBG5\u00A5\\dp[\u00ADV\u00AF\u00D7\u00F3<\u008F\u009C\u00B7\u00DBmd\u00E8\u00F0\u00E4\u00F4\u00C1m4\x1A\u0087\u00C3\u00E1x<\u00B2\u00E7\u00E0\x12\x1D\u00BA\u00DDne(t<\u009DN\u009DN\x07\u00DA\u00B1\u00FA\u00E6y\u00BE\u00DB\u00ED\u00A0\x03\u00A9\u00BAB\u00FBX\x1DH\x06\x1D%I\x12E\x11:\u00D0=\u009B\u00CDf\u00A6i\x16\x12\u00CB\u00A0 \u00AE\u00D7k\u00DF\u00F7Ad\u00F5u\x1C\x07O5\u00D7u\u009Fq\x14\x1AG\u009E\u00CF\u00E7\u00E8\u0094\u00EAKtX.\u0097\u00CF\u00D8\x14]c\u00BD\u00C9&\u00A2S\u00C2E\u00DEl6dn\u00BC/\x1E\u0082\u00B2\x1B\x0E.~\u0083\u00E88\x18\fn\u00F9\u00AD\f\u008A\u008AH\u00EF,7\fC:\u0099B\u00BF\u00DD\x19T\u009A\u00A6W'\u00B2,c\x1F\u00D9Y\u00D3\u00B9\x15>wj\u00B7FD\u0097\x1C\u00D1l6K\u00FC6\u0099L\u00EEC\u00E1n\u00D8\x1CY\u00D7u\u00B2O%~#\u00E8\u00FBPR\u00DD\u00E7\x1D\u00F5\u00AFw\x14\u00FES\u00BC\x16\u00FA+\u00C0\x00q\u00C6\u00D3\u00F9\u00EAy\u00AE\u008D\x00\x00\x00\x00IEND\u00AEB`\u0082";
              } else {
                var _clearConditionButtonIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x1C\x00\x00\x00\x1C\b\x02\x00\x00\x00\u00FDoH\u00C3\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u00C0IDATx\u00DA\u00ECV!\u0088\x02Q\x14\u00D4\u00BB\x13\u00DC5\u0089\u008A`\u00D8`Z\x04\u0083\u00C5bQA\u00B3U0\u00B9a\u00D9(\u00C8Y\u008C&\x11\x04\u00BB[7o\u00D0`\u00D6\u00A8\x06A\x10\u00C1`\u00D6z\x06\u00CB\r>X>\u00EB\u00FF\u00AB\u00C7\u00ED]r\u00C0\u00F2\u00BE;\u00BE?3\u00EF\u00AD\u00C1\u00E5r\x19\u00F0\x1B\x1F\u00F8\u00C4\u00E3q\x1F\x19\x13\u0089\u00C4[\u00E0\x0F\u00F0\"\u00FD/\u00D2f\u00B3y8\x1C\u00B8G\u008B\u00C5\u00E2\u00F3\x06\u00CB\u00B2D\u00A4\u00EF\u00BA\u00AE\u00CB\u00B2\u00EC\u00AA\u00A6\u00D3\u00E9~\u00BF\u009F\u00CDf\u00A3\u00D1\u00A8\u008Bq<\x1E\x7F\u00DD\u0080_]\u00AF\u00D7\u00C5b\u00D1\u00F5l$\x12\u00E1w\n\u00BAV\u00AB\u00D5\u00EB\u00F5\u00D8~\u00C18\u009B\u00CD\u00EA\u00F5\u00BAS9\x1E\u008F\u00DC~\u0085\u009A\u00DE\u00F3\u0082\u00B1\u00D3\u00E9T*\x15M\u00D3\u009C\u00AF\u00A1\u00D9g\u00AFOH&\u0093\u00A4\u00C3\u00F5z\u00CDd2\u00A5R)\x14\n\u00A1\u00AE(\n\u0086\u0090\u00E8$I\u00AAV\u00ABO]\u009F\u00ED\u00B7\\.O\u00A7\u00D3\u00EDv\u00CB\u00D6\x0B\u0085\x02\u00E9P\u00AB\u00D5~\x1C)\u00E8\u00B8\u00DF\u00EF\r\u00C3\x18\f\x06\u00AC\u00BE0\nG\u00D0\x01\u00EC\u00FC\u0085\"\u0082m\u00DB\u00AB\u00D5\n:B\u009Fp8\f}\u00BB\u00DD.\x04\u00C1\x114\u0081\u00B8\\F \u0088\u00D5\u00C7\u00DDR\u00F6\rx\u00D89\u00DDl6\u00C3\u00E1\u00B0\u00DDnC_\u00EF-%4\ny\u00BC\\.\u00BB\u00DD.\u009F\u00CF\u0093?\u00F0-\u0095J\u008DF#\u00F2MD*4\n\u00B7>\u009F\u00CF\u0094D4\x0B\x05I\u00C7\u00C9dB\u00BE\u0089\u00E6\u00CD\u00CB(6}\u00C4{:\u009DH\u00C7F\u00A3q?\x17\u008FI\u00C9Y\u00B6\x02^\f\u00BB\u00E3\fw\u00DE\x1E\u0090\u00BA\x18\u0081X,\u00E6J\u008F7/'R\u00F3\u00F9\u009C\r9\u00A0\u00AA\u00AA\u00C7\x1C\u009B\u00A6\u00F98R\u00B480|\u00B9\\N4\u00C1\u00DE\u0091\x12\u00E6\u00F4\u00F56\u00FD\u00D5?\x14\u00A8\u00E0/\u00E9\u00B7\x00\x03\x00\u00B2+\u00EAF\u00AAI\u0080S\x00\x00\x00\x00IEND\u00AEB`\u0082";
              }
              var _clearConditionButton = add ("iconbutton", undefined, _clearConditionButtonIcon, {style: "toolbutton"});
              with (_clearConditionButton) {
                size = [28,28];
                helpTip = "Remove Highlighting";
              } // END iconbutton _clearConditionButton
            } catch (e) {           
              var _clearConditionButton = add ("button", undefined, "X");
              with (_clearConditionButton) {
                preferredSize.height = 23;
                preferredSize.width = 23;
                graphics.font = "dialog:11";
                helpTip = "Remove Highlighting";
              } // END button _clearConditionButton
            } // END icon clear condition 
          } // END group _hitsButtonGroup
        } // END group _hitsGroup        
        var _liveModusGroup = add ("group");
        with (_liveModusGroup) {
          alignChildren = "bottom";
          var _live = add ("checkbox", undefined, "Live Modus");
          with (_live) {
            value = false;
            graphics.font = "dialog:11";
          } // END checkboxlive 
        } // END group _liveModusGroup
      } // END group _columnLeft    
      var _columnRight = add ("group");
      with (_columnRight) {
        orientation = "column";
        alignChildren = "fill";
        spacing = 15;
        var _findPanel = add ("panel", undefined, "");    
        with (_findPanel) {
          orientation = "row";
          alignChildren = ["right","fill"];
          margins = [13,15,13,4];
          var _findPanelColumnLeft = add ("group");       
          with (_findPanelColumnLeft) {
            orientation = "column";
            spacing = 5;
            var _inputGroup = add ("group");
            with (_inputGroup) {
              spacing = 0;
              margins.right = 2;
              add ("statictext", undefined, "Find what: ");
              var _inputGrep = add ("edittext", undefined, "", {multiline: false});
              with (_inputGrep) {  
                active = true;
                characters = 42;
              } // END edittext _inputGrep                       
              // Icon Sonderezeichen fuer Suche einfuegen
              try {
                if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                  var _wildcardsFindIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x14\b\x06\x00\x00\x00\u008D\u0089\x1D\r\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u0088IDATx\u00DA\u00ACT\u00BDJ\u00C3P\x18M\u00C5\u00CD\u00E4\x05\u00B2\u00B8%\x0F`\x1E }\u0081\u00CEb\u00E6\u00D2\u00C9E:\n\u00E2\x1E\x04\u00C1\u00A5tv\x17K\u00E7\x04\u00E7\u00F8\x00\u00E9,}\u0081\x1B7!\u009E\x03'r\u0089i\x12\u00B1\x1F\x1Cro\u00BE\u00EF;\u00F7\u00FB\u00BBwR\u00D7\u00B5sL9q\u008E,\u00A7}\u00CA\u00AA\u00AA\u00A6\u00F8\x04@\u00A8_\u00EF@\u00E6\u00BA\u00EE\u00FE\u0090\u00CF\u00A4+e\x10\u0091`)\u00A2\u00BD@\u0089\u00F4]\u0081\u00F4yT\u0084\"{\x00\fp\x03\u00C7\u00C2\u00D2y:h\u0081\u00B5\u0081\u00EE\u00B57B9\u00AC\u00B5\u009D\u00C3\u00C1\x1C(\x05\x0F\u00F4\u00A1\u00BF\x1Cj\u00CA\u008C\u0086@J28F\u00C0\x1A\u00D8\x02\u0089\u0088(\x1B\u00DAQ?D\x18\x03\x05\u00D3\u00841\u0089\u00EFu\x00k\u00B8\u00D0\u00DA\u0081>\u0093}8D\x18\u00AA\u0093\u0094+\u0080%\u00B8\x03\u00C1\\\u00FF\u00CA\u00D1sh\u0085_Z\x1D-\x15m\u00A3\u00DBY\u00B5\u00FE\u00F3`\u00FB\u00EA\u00B4\u00A3H\x1Dk|\u00A6\u00FAf}c\u00D3vf\u00A4lJ\u00A2\u00F4)\x01\u00F6\u008E\u00EA\u00D99\u00E0?\x11BY\u008A\u00F4\u00C2\u00EAd\u00E3\u00CCy\u00E3<&j\x14m\u00D3\u00CE\u00BC8\u0087\r\u008C1K\u00E0\r\b\u00B5\u00F7\tK\x1F\u00DA\u00FB.\u00B4\tI\u00B0\x05\u00D6\riK\u00EF5\u00EB,\u00CB6\u00C0y\u00DB\u00E6\u00D7]F\u008DfJ\u00D3S\u00D1\u00D9YW]\u00E7\u008C\u00AEh\u0097\u00E79\x1D?9V\u00C0c\x1C\u00C7_\u009Dw\u0099\u00F7\x13\u00A4\u0085\x1A\x11\u00A9\u00A3F5\u00DC\u00B5\u00CC\u00CFT\u00CB@At?_\u00EA^:\u00E2\u00F9\u00E3A\u00B7\u00C0\u00D3\u00A8\u00F7p@^\u0080k\u00A4\u00FA1\u00F8\x1E\u00FEG\u00BE\x05\x18\x00\u0090\x01\f\u00D98\u00AC\u00B5\x03\x00\x00\x00\x00IEND\u00AEB`\u0082";
                } else {
                  var _wildcardsFindIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x14\b\x06\x00\x00\x00\u008D\u0089\x1D\r\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u0084IDATx\u00DA\u00ACT\u00B1J\u00C4@\x14L\u00E4:\u00CD\x0F\u00A4\u00B1K>\u00C0|\u0080\u00F7\x03\u00E9\u0092\u00C2\u00D4beg)\u0088\u00FDq \u00D8\x1CW\x1F\x1C\u00A9\u00C4pu\u00C0:~@\u00AE\u0096\u00FB\u0081`'\u00C4\x19\u0099@X\u00F7.A\u00EF\u00C1\u0090Mv\u00DEd\u00DF\u00BE\u00D9u\u00DB\u00B6u\u008E\x19'\u00CE\u0091crh\u00D2u\u00DD)\x1E\x01\x10\u00EA\u00D3;P\u00A2\u00AA\u00DD\u00DE\x1C[\u00C9\x10\u00A2\u00C0\u009D\u0084v\x02#\u00D2s\u0081\u00BC\u0095U\u0091\u0082}Hd\x03\u00AC)`\u00CCy\u00C0#\u00F0\x06\u00C4f\u00EE\x0F\u00C7\u0092\u00B0\x16<[\u0082xsrlsfSb\u00C0\x07f\u0098lPz\x04,\u0081\r\u0090\x01s\u00F1\n\u00F28?\u00D4\u00E5K\u00A0\u0082X\x05\u00B2\u00AF\u00F2|\u00ED\u00E1\u008D\u00C6\\I)~8$\x18\u00AA\u0093\u008C+m\u00C1\x03\x04\u00AE\u00F5\u00AD\x1E\u00ED\u00C3\u00DE\u00F2\u00EB^Gk\u00AD\u00B6\u009B\u00DB\u008A\u00EB\u00FD\u00C5\u00D8,\u00AF\u00D1\u00B8\x13\u00E8\u00EC3\u00D5\u00B3<dl3\u0099+eS2\u0095\u00CF\b\u00F0\u00EEh?\u00AD\x06\u009F\u00F4\u00FCX\u0083L\u00D1\x0B\u00FD\u00B9\u00D0\u009E2y\u00A5q&zE'\f\x1A[\u00A7\u0083\u00A6\r\u00F5\u00CE\u00B2}\u00C3\u00F4\u00FE>\x7F\u00DA\u008C\u00ED\u00EB\u0094,;Q\u00D3\u00F8\u00DD8I\u0092\x02879\u00BF\u00CE2\u00CA\u008EU\u00A6\u00A7\u00D2\u00D9\u00D93u\u009D\x1E]\u0090\u0097\u00A6)\x13?i+\u00E0)\u00CF\u00F3/\u00EBm\u0083\u0084W\u0088VjD\u00A4\u008E6\u00DA\u00B7\u00ADA?\u00D5^\x06Z\u0084\u00FD\u00FAR\u00F7f#\u00AE?\u00FE\u00E8\x1Ex\x1Eu\x1F\x0E\u00C4\x0Bp\u008BR?\x06\u00EF\u00C3\u00FF\u00C4\u00B7\x00\x03\x003\u00FC\x17\r\u00F9\u00EA\u00C2\u00F2\x00\x00\x00\x00IEND\u00AEB`\u0082";
                }                
                var _wildcardsFind = add ("iconbutton", undefined, _wildcardsFindIcon, {style: "toolbutton"});
                with (_wildcardsFind) {
                  size = [22,22];
                  helpTip = "Special characters for searching";
                } // END iconbutton _wildcardsFind
              }
              catch (e) { 
                var _wildcardsFind = add ("button", undefined, "@");
                with (_wildcardsFind) {
                  size = [22,23]
                  helpTip = "Special characters for searching";
                } // END iconbutton _wildcardsFind
              } // END Icon Sonderezeichen einfuegen            
            } // END group _inputGroup 
            var _findFormatGroup = add ("group");
            with (_findFormatGroup) {
              alignment = "right";
              margins.right = "27";
              // Icon: Refresh FindStyles
              try {
                var _refreshFindStylesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x12\x00\x00\x00\x11\b\x06\x00\x00\x00\u00D0Z\u00FC\u00F9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01=IDATx\u00DA\u00AC\u00D4=H\x03A\x10\u0086\u00E1\u00BDD4*\bZ*A\u00B1\u00B3Ke%b\u00A1\u00A0\x07\x01[\u0083\u0085\u00B5\bi\u00D2\u00A4\u00B6\u00B1\x14\x05{\x0B\x7FJA\u00B4\u00B3\u00B2S\u008BtV!\u0085\u00C4RA\u0088\x1A\u0089\u009E\u00EF\u0084\x11\u0086e\u00AF\u00F2\x16\x1E\b\u00BB\u00CBw\u00B7;sqI\u0092\u00B8\u00FF\x0E\u00C9\x18HY\u009B@\u008CyL\"\u00876\u00EEq\u00817\u00DD\u00B7\u00813\u00F9\x11IZ\x14E6d\x01;\x18\u00C5'\u009Ed\x1F\u008A\x18B\x07\x07\u0098F\x05\u00E5~\u0086\x17\u00B4\u0088\x1A\u00DEq\u008C\x1B|\u00E9\u00DA \u0096\u00B1\u0085a\u00F3\u00E0\u00B2\x7F\u00B4qlkH\x1D-\u00EF\u00B8\x12x\u00ADo\x12\u00FBwa\u0083f\u00D1\u00C3I \u00C4\u0099;\u0089C\x0B\u00FE\u00D1$X\u00CA\u00F8\x1D\u00D8+\u00F73\x17\u0098o\u00F4+\u009FU\u00F9s.\u00A3a\u00EF\u00A8\x14X\x7FD70\u009F\u00D7\u0096\u00E8\u0085\u0082v\u00BD\u00CD\u00D2h\u008D\u0094\x17X\u00C1&\u00F6\u00F1\u00E0\x07\u00D9!e>MY\u009B\u00D1^\u0092\u00D1\u00FC\u009BL\u00BB\u00A3%\u00ACi\x13:\u00D3\u0090\u00AB\u00D8\u00C3\b\u008E\u00F0\x1A*\u00FF%\u00CE\u00B5\u0087\u00AA\u00BA\u00B9\u00AB\u009FH\u00A2\u009FH\x01\x1F8\u00C4\u00AD\u00AD\u009A\r\u00AA\u0098\u00E3\u008Ca]?\u00DA)\u00FC\u00E0\x19w\u00B8\u00C2\u008B_~\u0097\u00E9\u00DFH\x16a\u00BF\x02\f\x00\u00BD/g\u00CDu\u00B8\u009C'\x00\x00\x00\x00IEND\u00AEB`\u0082";
                var _refreshFindStyles = add ("iconbutton", undefined, _refreshFindStylesIcon, {style: "toolbutton"});
                with (_refreshFindStyles) {
                  size = [24,24];
                  helpTip = "Refresh character and paragraph styles";
                }
              }
              catch (e) { 
                var _refreshFindStyles = add ("button", undefined, "R");
                with (_refreshFindStyles) {
                  size = [24,24];
                  graphics.font = "dialog:11";
                  helpTip = "Refresh character and paragraph styles";
                } // END button _refreshFindStyles
              } // END Icon: Refresh FindStyles          
              var _findCharacterStyles = add ("dropdownlist", undefined, _doc.characterStyles.everyItem().name);
              with (_findCharacterStyles) {
                graphics.font = "dialog:11";
                graphics.foregroundColor = graphics.newPen (graphics.PenType.SOLID_COLOR, [0.13, 0.13, 0.13], 1);
                maximumSize.width = 165;
              } //END dropdownlist _findCharacterStyles
              var _findParagraphStyles = add ("dropdownlist", undefined, _doc.paragraphStyles.everyItem().name);
              with (_findParagraphStyles) {
                graphics.font = "dialog:11";
                graphics.foregroundColor = graphics.newPen (graphics.PenType.SOLID_COLOR, [0.13, 0.13, 0.13], 1);
                maximumSize.width = 160;
              } // END dropdownlist _findParagraphStyles
              writeStyleItems (_findCharacterStyles, _findParagraphStyles);        
            } // END group _findFormatGroup             
            var _placesGroup = add ("group");
            with (_placesGroup) {
              alignment = "right";
              margins.top = 16;
              margins.right = "27";
              // Icon: Ausgeblendete Ebenen und Objekte einschließen
              try {
                if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                  var _hiddenLayersIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x13\x00\x00\x00\x11\b\x06\x00\x00\x00?\u0098\u0097\u00C7\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x02\u00E9IDATx\u00DA\u008CT[H\u00D3a\x14?\u00FF\u00FD\u00E7\u00BCl\u00EA\\\u00A6\u00AB\rT\u00BCnZ\x1B9d\u0094 {\x0B\u0082\u00C0\u00A7^\u00A4\u0087ADQ\u0090\u00DD\x18\u00BD\t\u0083\u00EA%\u009F\u00C2^\u00F2\u00C5\x1E\u00A2B}\t\x1F\u0086F\u0081\u008A\x18\u00F3ApK\u00F7\"\u00BB4w\u00D3\u00E9p,\u00D8\u00D6\u00EF\u00FC\u00C9?3/u\u00E0p\u00CEw\u00BE\u00F3\u00FD\u00BEs\u00FB>abb\u0082N\u00A3\u00F1\u00F1\u00F1\u00AB\x10/\u00C0\x1E\u00F0\u0088\u00D3\u00E9\u00CC\u0094\u00EE\x0F\r\r\u00C9\u00BA\u00E2\x14\u00906\u00F0dMM\u00CD\u00CC\u00C0\u00C0\u0080\u00A5\u00BD\u00BD\u00FD1\u00CC~\u00D8n\u009CtFy\f\u0088\x06\u00E2YYY\u00D9#\u00AB\u00D5\u00AA\u00EA\u00EE\u00EE&\u0085BA\u00AD\u00AD\u00AD\u00D4\u00D9\u00D9iXXXx\x0F\u009F[\u00F0\u00B9\u008F(}\u00A5g\x05\u0097\u00CB%)KKK\x02\u00C4M\u00F0sDq\u00AE\u00B7\u00B7\u0097\u00AA\u00AA\u00AA\u008E\u00DC^(\x14\u00C8\u00EF\u00F7\u0093\u00D7\u00EB\u00FD\x05\x1A\u0085\u00C9=77\u0097\u0091\u00C1\x00d\u0087>\u00DA\u00D0\u00D0`\u00EF\u00EB\u00EB#H\u00FA\x17e\u00B3YZ^^\u00A6@ \x10\u00C4\u00F2!\x00?\t\x0E\u0087\u00E3%\x16O\u00ECv\u00BB`6\u009B\u008FD\x11\x0EGhw7MMMM\u00A4\u00D1h\u008E\u0080nmm\u00D1\u00E2\u00E2\"\u00A5R)\u008F\u00D8\u00D2\u00D2\u00E2\u0085M\u0087\u00C5%\u00B5Z-\u00D4\u00D5\u00D5IN;;;\u00B4\u00BE\u00BEN\u00C5bQ\x02\t\x06C\u0084\u00B4\u00A8\u00BA\u00BAZ\u00AA\u00E1\x01UVVR.\u0097\u00A3h4z\u00BE\u00B4f\u0097!\u00C6\x1A\x1B\x1B/\x1A\f\x06\x12\x04\u0081\u00A0\u00CBu\u00CB\u00E7\x0B\x14\u008F\u00C7h\x7F\x7F\u009F\u009A\u009B\u009BI\u00AB\u00D5\u00E2\u0082 \u009FC\u00E4\u00BB\u0093p\x19\u0096\u00BB\x19\u0089D\u00BEC|\u008C\u00C7\u00E3f\u00B0\x12\u009D\u00A4\u008A\u008A\n9\x02QT\u0090^\u00AF\x07X\u0096|>\x1FmnnR&\u0093\t \u00CA\u00BB\u00A8\u0097G\x1E\u008D\u00A9\u00A9)\x07\u00C4k8\u009B,\x16\x0B)\u0095J\u008A\u00C5b\x12wtt\u0090N\u00A7\u0093k\x18\u008D\u00FE\u00E4\u008B%\x1D\u0097\u009E\u00CD\u00E7\u00F3m]]]\u00B3\u00E8pA\u00C0\u00EC\u00BCBJ\x0Fl6\u009B`4\x1A\x0F\x15woo\u008F\x12\u0089\x04\u00D5\u00D7\u00D7K\u0080\u00E8\u009C\x04\u00C2eP\u00A9T\u00D2\u00FE\u00CA\u00CA\n%\u0093\u00C9y\u00B8\u00DF\x16\u00E1\u00C8\r0\"\u00EF\x0B\u00B5\u00B5\u00B5\u0087f\u00AB\u00BC\u00BC\u009C\u00D8\u00C6\u0087\u00B8>\f\u00CA\u00A9\u008A\u00A2(\u00ED3 \"\u00E3\f\u00F4XF\u0085\u0083\u00B7\u00E9v\u00BB\u00AFA\u00BCAq\u008D===\u0084\x17p\u00EA\u009C\u00A5\u00D3i)\u00AA\u00ED\u00ED\u00ED\u00AF\x1C\x15\u00D2\u00FC!\"M\u00CE\u009DL&\u00D3\x06\fo1\x12ZDa\u00E31\u00E11\u00F8\u009B8\u0092\u00B5\u00B55~\x01I\f\u00EE=\u00EE\"\u00CE%\u00A4&\u00F5\u00F7\u00F7\u00CB\u008E\x00\u00CC\u0081?\u00AF\u00AE\u00AE~\t\u0085BW\u00D0\u00AD3\u009C\x1A7\u0084\t\u00B3\u00C4\x03Z\u00C4\u00A0\u00BE\u00C3\u00F2\u00FA\u00E0\u00E0\u00E0\u00FC\u00F4\u00F4\u00F4\u00C9\x0F\u009D\tN\u00DF\u00D0a+\x00GP\u008Fa<v%w6\x1C\x0Eo`\u00FB\x0E\u00F6g\u00FF\u00EB\u00D7(\x01\u00CCB<\x05\u00E8\x07\u00D4f\f\u00FA\f\x7F\x02\x7F\u00EC\u00C7\u00D2o\x01\x06\x00D\rX\u00B7\u00B0\u00E9\u00CE:\x00\x00\x00\x00IEND\u00AEB`\u0082"; 
                } else {
                  var _hiddenLayersIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x12\x00\x00\x00\x11\b\x06\x00\x00\x00\u00D0Z\u00FC\u00F9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01xIDATx\u00DA\u00CC\u0092\u00BD\u008A\u00C2@\x14\u0085O\u0096 \u008AE\x04\u00B7QRG\u00F6\r\u00A2\u00B2\u00DB\u00E5\x05\x02\u00A9l|\t!\u00A4\x13K\u00C1\u00C2.\u0085E\u009E\u00C0\u00C2\u00C6z1y\x07E\fi\u00C4b\x1B\x1B\x05\u00C5\u008C\u00990#\u0093\x10w\x1B\u008B=0\u00CC\u00E4\u00FE|\u0084s\u00AFD\b\u00C1+\u00F4\u0086\x17\u00E9\u00FF\u0081@=\u00FA\u00C5'm4\x1A\x11\u00DB\u00B6i\u0081\u00F6\u00AC\u0097\x1E\u0089C$I\u00CA\x00&\u0093\u00C9\u00FAp8<\x1Ah\u00BER\u00A9`8\x1C\u00B6\u0092\u00D0\u0086\u00C7\u00B9\u00F2 \u00CDu\u00DD\u00F5v\u00BB\u00CD\u00833\u00AA\u00D5jp\x1C\u00A7\u0095\u00F4n\u008A@\u00DA`0X\u008B\x00\u009A\u00ABV\u00AB\u00B8\\.\u00B8^\u00AF\u00C8\u00E7\u00C6\u00E3\u00F1\x03&\u009A\u00BD\u00A1\u0089z\u00BD\u009E~\u00C4q\fUU1\u009DN\u00B1\\.\u00D1h4p\u00BB\u00DD\u00D2\\\u00B9\\\u00CE@2\x7F$j\u00B1X\x10\u00CB\u00B2\u00E0y\x1ED/\u00FA\u00FD>f\u00B3\x19z\u00BD\u009E\u00F4\u00E7\u00F8\u00DB\u00ED61\f\x03\u00BB\u00DD\x0EQ\x14A\u0096e\u0094J%\u0084a\u0088\u00D5j\x05\u00D34\u00D1\u00E9t\u00C8\u00D3\u00F1S\u00C0\u00E9t\"\u00E7\u00F39\u00BD\u00F9\t\u0082\u0080\u00CC\u00E7\u00F3L\u008C\u00D7\u00E9\u00BAN\x1E\u00EB#\u00EC\u00D1Gr>9Pl\u00C8Ch\r\u00AD\u00A5=E \u0085\u00C1R \u00FD\u00FD<L\x04\u0088\u0090\u00CCB\u00B2\x15P\u00D8\u00B3\u00C9\u00EE\u00F7n\u00B7\u00FBM\x1F\u00BE\u00EF\x7F%\u00D7\x0F\u008B\u00EF\u0099-\u00C7\u00C2\u00A9\u00B1=Q\x04\x0B\u009B9K\u00F7\u00C2\u00FB(N\u00B4\b\u00C4\u00A5<Y\u00EC\u00A38(\u00AE\u00BB\x00\x03\x00\u00B2X*#\"J-\u009D\x00\x00\x00\x00IEND\u00AEB`\u0082"; 
                }
                var _hiddenLayers = add ("iconbutton", undefined, _hiddenLayersIcon, {style: "toolbutton", toggle: true});
                with (_hiddenLayers) {
                  size = [20,19];
                  helpTip = "Include hidden layers and objects";
                } // END iconbutton _hiddenLayers
              }
              catch (e) { 
                var _hiddenLayers = add ("checkbox", undefined, "");
                with (_hiddenLayers) {
                  helpTip = "Include hidden layers and objects";
                } // END iconbutton _hiddenLayers
              } // end Icon: Ausgeblendete Ebenen und Objekte einschließen
              // Icon: Musterseiten einbeziehen 
              try {
                if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                  var _masterPagesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x13\x00\x00\x00\x11\b\x06\x00\x00\x00?\u0098\u0097\u00C7\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x02\bIDATx\u00DA\u00ACS\u00B1N\x1BA\x10}k\u00B9\u008ES\u00F8\x03l\t\u00CB\x0Er\u0083\u00EF\u0090\u00A0\u008B\x0B\u00FC31\rBD\n\u008D[\u00D2\x01\u00CE\u0087\\z\u00A7 M,%\u008DI|\u00E7s\x15\u00C7\u00C2\u008D\x0B@\u00823\x11\u00B7\u009B\u00D9\u00D9\u00DB\u0093\u00CF B\u00A4\u00DCi\u00B5;\u00F3f\u00DE\u00CE\u00BC\u00DD\x15J)\u00FC\u00AF/\u00F7\u009C\u00A0Z\u00AD\u00A6h\u00FC5N\u00AC\u00D8N\u00B5Z\u00FD\u00FA\u00DCJF\u00A3\u0091K\u00D3\u00B7\u00C7\u00C8R\u00A2n\u00B7\u009BIj\u00B7\u00DB\u008F\u00FAV\ts\u00CBDovw\u00D9\u0090RA)\t%%d\u00A2\u00A9\u00A4\u00B5\u00D6W.\u00F9t|\u00A9T\u00D2\x058\u0096,C\u00A4?M\u00A4\tu\u0092\u008A\u00A5\u00F1i;\u0096\u0089/Nc\u00F7\u00F6\u00F7\u0091t\u00E4\u00E4mk\x1FNO\u00D3\x00\u00AE\u0082~\u00C1\u00C4\u00D6\x17C\t\u00C1\x0E\u00A1\u008C:\u00CB9\u009A'\u00AF\x17GG\u00EFY=A\u0089\u0093_\x13|>;\u00C3\u00AB\u00F5u\x14^\x14\u0090\u00E4\u00E1\u00F7\u00FD=\u0093O&?qq1\u00C3\u00E1\u00BBC\x14^\x16\u00CC\u00A6\x14t\u00F0\u00F6\x00y\u00DB\x16\u0092*<\u00CF\u00C3t:\u00C5\u00CDm\u0084f\u00F35\x11\b[\x1At\u0091\u009E\u00F7\u00D1\u00E0\u00AD\x1B\u00C2\u009B\\\u0084\u00BD\u00AB9C\u00A2X\u00A3\u00C5b\u0081\u00C1`\u0080Vk\x07\u00C3\x1F\u00DF\x13\u009D\u008C>Z\u00AB\u00C8\u00E2;-\f\u0087CsP\u00B1\u00C9M\u00C9X#\x1A\u00BE\x1F\u00D0\u00E9\u0094y\f\u00CE\u00CFqy}\u00959\u00CD\u00C0\u00F7Q.\x13^.1\u00E9\u00F5\u00D5%\u00E1F\u00DFLez\u0084\u00E3P[\u0098\u00CDf\f\u00FA\u00B4\u00BBm\u00C1\u00E0c\u009E->$r\u00CE\u0095\u00F2a\u009B\u009Fz=\u00D4\u00EBu\u00B6\u00F5\x1C\x04\u00A3\u0094L\u00E3\u00BD\x07x`\u00AE\u0091Z!\x1B\u0087!;\u00B6\u00B6\u00B7\u00E0\u00BA\u009Bh4\x1A\u00E8\u00F7\u00BF \u008A\"\u00F6\u0087\u00E1\u0088\u00E7m\u008Do\u00BA\u00D8hl\x10\u00DE'\u009D\u00EF\u0090tiOSa\u00AD\u00B2\u0086\u00E3\u0093csvd;\u008EK\u00A4\u00AE\u008DC\u00A5R!\u00FC$\u00C1\u00C1\x1B\u00EA!\u00A0\u00D2\u00DB \u00FE\u00F5q?\u00F5\u00E8\x05\x11\u00A1\u00D3\u00E9<\x19H\u00B8.P\u00D8\u00C7>\u009F\u00CFy.\x16\u008B\u0099\u00B8?\x02\f\x00Z\u00E9`\u00B5wK\u00A3\u009F\x00\x00\x00\x00IEND\u00AEB`\u0082";
                } else {  
                  var _masterPagesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x12\x00\x00\x00\x11\b\x06\x00\x00\x00\u00D0Z\u00FC\u00F9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u00B2IDATx\u00DA\u00ACT\u00BB\u008A\x02A\x10\u00EC=.\x11\x03\x03\u00A3\u008B\u00D6@P4\x12\x04\u00BD\u00C4G\"~\u0083\u00A9\u0082\x1Fb\u00EA\u0097\u00F8\x05jd\"\u0097if\u00A4\u00E2\u0082\u00B0\u00A8(\u00BBr\u0082\u00EF\u00BE\u00A9F\u00C5\u00BD\u00F5T\x0E\x1B\u009A\u009E\u009E\u00E9\u00EA\u00A9\u00A9\u0099]\u008D\u0099\u00E9\x15\u00F6F/\u00B2\u0087\u008D*\u0095\u00CAs\u0094q\u00B4{\x1E\u008F\u00C7\u00F9Q\r\\\u00FB\u00ADQ\u00A1P\u00E0\u00F9|.c\u008F\u00C7C\u0086aP8\x1C\u0096\\\u00D34Z,\x16T\u00AF\u00D7\u00B5\u00BB\u008C\u00AA\u00D5*'\u0093I>\u00DB\u00F1x\u00E4h4\u00CA\u00FB\u00FD^|\u00BB\u00DDr.\u0097\u00E3r\u00B9\u00ECb\u00F9~nX*\u0095\u00B8\u00DF\u00EF\u00D3f\u00B3\u0091\\5\u0091\u00B8\u00DB\u00EDd\u008CbD\u00B0j4\x1A\x14\b\x04x4\x1A]\u0098]\x1A\u00ADV+j\u00B5Z\x17\u00C09\u00C2\x15\x1B\u00C9\x11k\u00B5\x1A\x1D\x0E\x07\u008A\u00C5bh\u00AA\u00ABy\u00C3qk^\u00AFW@\u00DDn\u0097\u00F2\u00F9<u:\x1D\x01\x02\x04V\u00C83\u0099\u008CD\u00CC\u0081\u00D9I7\u009FC\u00A3b\u00B1(:d\u00B3Y^\u00AF\u00D7\u009CN\u00A7\u00D9\u00B6m\u00D6u\u009Dg\u00B3\x19G\"\x11\u009EL&\u00EC\u00F7\u00FB\u00D94M\u00C6\u00D1\x14\\W\u00EEsh\x04\u00C3N\u00D0(\u0095J\t\x0B0R\x02K\u009CN\u00A7\x14\f\x06%G\u00DDr\u00B9\u00FC\u00FBA\x02`Y\x165\u009BMR\u00BB\x0B\b\u008Dqd\u00CC\u00F7z\u00BD\u00E7\x1B\u00B5\u00DBma\x03\u00AD`h\x04\u00E0`0\u0090\u00F5\u00E1p\u00E8\u00D0\u00C8uk\u00E3\u00F1\u0098B\u00A1\u0090c\x11\u00C5`\u0090H$DG<F\u00E4\u00B7\u00EC\u00F2\u00B2q\u0095*|\u00B8\n4\u00EDK\u00D5|\u00DE\u00C0\u009A\u00A7h\u00A9u\u00FB\u00FAh\u00D6i\u00D1\u00E1\u00EA\u00A3\u00A5\x1B\u00F3\u00DFW\x18\x17#\x04\u00DF?\u00FE 6z\u00FC\b0\x00\u00ACr\u0094t\u00B7\x06s:\x00\x00\x00\x00IEND\u00AEB`\u0082";
                }
                var _masterPages = add ("iconbutton", undefined, _masterPagesIcon, {style: "toolbutton", toggle: true});
                with (_masterPages) {
                  size = [20,19];
                  helpTip = "Include Master Pages";
                } // END iconbutton _masterPages
              }
              catch (e) { 
                var _masterPages = add ("checkbox", undefined, "");
                with (_masterPages) {
                  helpTip = "Include Master Pages";
                } // END iconbutton _masterPages
              } // end Icon: Musterseiten einbeziehen
              // Icon: Fußnoten einbeziehen
              try {
                if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                  var _footnotesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x13\x00\x00\x00\x11\b\x06\x00\x00\x00?\u0098\u0097\u00C7\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00C8IDATx\u00DAb\u00FC\u00FF\u00FF?\x03\u00B5\x00\x0B2\u0087\u0091\u0091q\u0099\u00BA\u00BAz$\u00B1\u009Ao\u00DE\u00BC\u00B9\x1C\u00E8\u0098(\u00B8~d\u0097ihh\u00FC\x0F\f\f$\u00DA%\u00EB\u00D7\u00AFg\u00B8q\u00E3\x06#V\u0097\u00C1\u0080\u00B3\u00B33A\u0083\u00F6\u00EE\u00DD\u008B\u00DF\u009B\u00C8`\u00C7\u008E\x1D\f,,\u00A8\u00D2\u00C0``\u00F8\u00F3\u00E7\x0F\u0083\u00BB\u00BB;\u00E10C\x06\x1E\x1E\x1E\u0094E\x0028t\u00E8\x10\x03\x13\x13\x13\u00D85\u00B0p\u00B5\u00B1\u00B1!\u00CF0;;;\u00EA\u00B9l\u00CF\u009E=X\u00C5]\\\\H7\f\u009F&\u0092\f\u00C3\x16\u00EDd\x19&--\u00CD\u00E0\u00E7\u00E7GP\u00E3\u00A6M\u009B\u0088\u00F7fff&N\u0083\u00A6O\u009F\u008EU\u009C\u0089\u0081\u008A\u0080\u0085T\u00DBI6\f[x\x10\x03PJ\rJ\u008B \u0080\x00\x03\x00\u0093;@\u00F2\u00AC\u0083\u009Cm\x00\x00\x00\x00IEND\u00AEB`\u0082"; 
                } else {  
                  var _footnotesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x12\x00\x00\x00\x11\b\x06\x00\x00\x00\u00D0Z\u00FC\u00F9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00F7IDATx\u00DA\u00AC\u0093M\x0E\u0083 \x10\u0085\u00A11q\u00D9\u009E\u00CA;x\x057\u00BA\u00D5\u00ADQ\u0097F\u00E3\u0089\u00BC\u0084\u00D7(\x1B\u00E3\u00BF\u00F5\u0091b\u00D0\u00B6b\r/!\x03\u00C8|\u0099\u00C7\b\u009D\u00E7\u0099\u00E8\u00D0\u008Dh\u0092!/\u00B2,\u00FB\u00AB<\u00CF\u00F3\x1EK`pe\u00EC?\u00BA\u00AE\u00FB3Q\u00BE\u0086<\u00CF\x11\x1E\u00EF%\u00DBXk\u00DBV\u008F5Y\u00BE\u00EF\u00F3H)\u00DDT\u0083\x18\u00C7\u00F1yP\u0092$\x1F\x00\u008Ci\u009A\u00C80\fj\u0090H\f\u0082`\u00B3\x1F\u0086!\u0087@J\x10l\bP\x14Ek\x15\u00A2\x12y\x1C\u0082D\u00D2~>\u008E\u00E3\n\u00DBw\u00EF+\u00C84MR\x14\u0085\u009E\u00AEY\u0096\u00C5\u00A3\u00B0\u0080\u00FB\u00C0\x10\u00EB\u00BE\u00EFI\u00D34\u00A4\u00AA\u00AAc\x10\x0EBi\u009A\u00AEv\u00845D@m\u00DBVW\u0084\u00C3\u0090\u00E38<\t`D\u00EC\u00E3\u0087\u00AD\u00EB\u009At]\u00A7\x06\u0095ey\u00E9\u008E\u00A8\u00DC\u0081\u00A5\u00FDw\u00E9\u00FD\u009C\u00D5sa\u00B0}E\u00EC\u00EA[{\t0\x00N\x16\u00C4\x0Bk\u00DB\u0090o\x00\x00\x00\x00IEND\u00AEB`\u0082"; 
                }
                var _footnotes = add ("iconbutton", undefined, _footnotesIcon, {style: "toolbutton", toggle: true});
                with (_footnotes) {
                  size = [20,19];
                  helpTip = "Include Footnotes";
                } // END iconbutton _footnotes
              }
              catch (e) { 
                var _footnotes = add ("checkbox", undefined, "");
                with (_footnotes) {
                  helpTip = "Include Footnotes";
                } // END iconbutton _footnotes
              } // end Icon: Fußnoten einbeziehen
              add ("statictext", undefined, "Search:");
              var _places = add ("dropdownlist", undefined, ["Document", "Story", "Text Frame", "Tables", "Selection"]);
              with (_places) {
                selection = 0;
                minimumSize.width = 160;
              } // END dropdownlist _places
            } // END group _placesGroup
          } // END group _findPanelColumnLeft
          var _findPanelColumnRight = add ("group");       
          with (_findPanelColumnRight) {
            orientation = "column";
            spacing = 10;
            var _findButton = add ("button", undefined, "Find", {name: "ok"});
            var _exitButton = add ("button", undefined, "Done");
            with (_exitButton) {
              alignment = "right";
            } // END button _exitButton
          } // END group _findPanelColumnRight
        } // END panel _findPanel    
        var _changePanel = add ("panel",undefined,"");    
        with (_changePanel) {
          orientation = "row";
          alignChildren = ["right","fill"];
          margins = [13,15,13,4];
          var _changePanelColumnLeft = add ("group");       
          with (_changePanelColumnLeft) { 
            orientation = "column";
            spacing = 5;
            var _changeGroup = add ("group");
            with (_changeGroup) {
              spacing = 0;
              margins.right = 2;
              add ("statictext", undefined, "Change to: ");
              var _changeGrep = add ("edittext", undefined, "", {multiline: false});
              with (_changeGrep) {           
                characters = 42;
              } // END edittext _changeGrep
              // Icon Sonderezeichen fuer Suche einfuegen
              try {
                if(app.scriptPreferences.version > 8 && app.generalPreferences.uiBrightnessPreference < 0.5) {
                  var _wildcardsChangeIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x14\b\x06\x00\x00\x00\u008D\u0089\x1D\r\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u0088IDATx\u00DA\u00ACT\u00BDJ\u00C3P\x18M\u00C5\u00CD\u00E4\x05\u00B2\u00B8%\x0F`\x1E }\u0081\u00CEb\u00E6\u00D2\u00C9E:\n\u00E2\x1E\x04\u00C1\u00A5tv\x17K\u00E7\x04\u00E7\u00F8\x00\u00E9,}\u0081\x1B7!\u009E\x03'r\u0089i\x12\u00B1\x1F\x1Cro\u00BE\u00EF;\u00F7\u00FB\u00BBwR\u00D7\u00B5sL9q\u008E,\u00A7}\u00CA\u00AA\u00AA\u00A6\u00F8\x04@\u00A8_\u00EF@\u00E6\u00BA\u00EE\u00FE\u0090\u00CF\u00A4+e\x10\u0091`)\u00A2\u00BD@\u0089\u00F4]\u0081\u00F4yT\u0084\"{\x00\fp\x03\u00C7\u00C2\u00D2y:h\u0081\u00B5\u0081\u00EE\u00B57B9\u00AC\u00B5\u009D\u00C3\u00C1\x1C(\x05\x0F\u00F4\u00A1\u00BF\x1Cj\u00CA\u008C\u0086@J28F\u00C0\x1A\u00D8\x02\u0089\u0088(\x1B\u00DAQ?D\x18\x03\x05\u00D3\u00841\u0089\u00EFu\x00k\u00B8\u00D0\u00DA\u0081>\u0093}8D\x18\u00AA\u0093\u0094+\u0080%\u00B8\x03\u00C1\\\u00FF\u00CA\u00D1sh\u0085_Z\x1D-\x15m\u00A3\u00DBY\u00B5\u00FE\u00F3`\u00FB\u00EA\u00B4\u00A3H\x1Dk|\u00A6\u00FAf}c\u00D3vf\u00A4lJ\u00A2\u00F4)\x01\u00F6\u008E\u00EA\u00D99\u00E0?\x11BY\u008A\u00F4\u00C2\u00EAd\u00E3\u00CCy\u00E3<&j\x14m\u00D3\u00CE\u00BC8\u0087\r\u008C1K\u00E0\r\b\u00B5\u00F7\tK\x1F\u00DA\u00FB.\u00B4\tI\u00B0\x05\u00D6\riK\u00EF5\u00EB,\u00CB6\u00C0y\u00DB\u00E6\u00D7]F\u008DfJ\u00D3S\u00D1\u00D9YW]\u00E7\u008C\u00AEh\u0097\u00E79\x1D?9V\u00C0c\x1C\u00C7_\u009Dw\u0099\u00F7\x13\u00A4\u0085\x1A\x11\u00A9\u00A3F5\u00DC\u00B5\u00CC\u00CFT\u00CB@At?_\u00EA^:\u00E2\u00F9\u00E3A\u00B7\u00C0\u00D3\u00A8\u00F7p@^\u0080k\u00A4\u00FA1\u00F8\x1E\u00FEG\u00BE\x05\x18\x00\u0090\x01\f\u00D98\u00AC\u00B5\x03\x00\x00\x00\x00IEND\u00AEB`\u0082";
                } else {
                  var _wildcardsChangeIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x14\b\x06\x00\x00\x00\u008D\u0089\x1D\r\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01\u0084IDATx\u00DA\u00ACT\u00B1J\u00C4@\x14L\u00E4:\u00CD\x0F\u00A4\u00B1K>\u00C0|\u0080\u00F7\x03\u00E9\u0092\u00C2\u00D4beg)\u0088\u00FDq \u00D8\x1CW\x1F\x1C\u00A9\u00C4pu\u00C0:~@\u00AE\u0096\u00FB\u0081`'\u00C4\x19\u0099@X\u00F7.A\u00EF\u00C1\u0090Mv\u00DEd\u00DF\u00BE\u00D9u\u00DB\u00B6u\u008E\x19'\u00CE\u0091crh\u00D2u\u00DD)\x1E\x01\x10\u00EA\u00D3;P\u00A2\u00AA\u00DD\u00DE\x1C[\u00C9\x10\u00A2\u00C0\u009D\u0084v\x02#\u00D2s\u0081\u00BC\u0095U\u0091\u0082}Hd\x03\u00AC)`\u00CCy\u00C0#\u00F0\x06\u00C4f\u00EE\x0F\u00C7\u0092\u00B0\x16<[\u0082xsrlsfSb\u00C0\x07f\u0098lPz\x04,\u0081\r\u0090\x01s\u00F1\n\u00F28?\u00D4\u00E5K\u00A0\u0082X\x05\u00B2\u00AF\u00F2|\u00ED\u00E1\u008D\u00C6\\I)~8$\x18\u00AA\u0093\u008C+m\u00C1\x03\x04\u00AE\u00F5\u00AD\x1E\u00ED\u00C3\u00DE\u00F2\u00EB^Gk\u00AD\u00B6\u009B\u00DB\u008A\u00EB\u00FD\u00C5\u00D8,\u00AF\u00D1\u00B8\x13\u00E8\u00EC3\u00D5\u00B3<dl3\u0099+eS2\u0095\u00CF\b\u00F0\u00EEh?\u00AD\x06\u009F\u00F4\u00FCX\u0083L\u00D1\x0B\u00FD\u00B9\u00D0\u009E2y\u00A5q&zE'\f\x1A[\u00A7\u0083\u00A6\r\u00F5\u00CE\u00B2}\u00C3\u00F4\u00FE>\x7F\u00DA\u008C\u00ED\u00EB\u0094,;Q\u00D3\u00F8\u00DD8I\u0092\x02879\u00BF\u00CE2\u00CA\u008EU\u00A6\u00A7\u00D2\u00D9\u00D93u\u009D\x1E]\u0090\u0097\u00A6)\x13?i+\u00E0)\u00CF\u00F3/\u00EBm\u0083\u0084W\u0088VjD\u00A4\u008E6\u00DA\u00B7\u00ADA?\u00D5^\x06Z\u0084\u00FD\u00FAR\u00F7f#\u00AE?\u00FE\u00E8\x1Ex\x1Eu\x1F\x0E\u00C4\x0Bp\u008BR?\x06\u00EF\u00C3\u00FF\u00C4\u00B7\x00\x03\x003\u00FC\x17\r\u00F9\u00EA\u00C2\u00F2\x00\x00\x00\x00IEND\u00AEB`\u0082";
                }                
                var _wildcardsChange = add ("iconbutton", undefined, _wildcardsChangeIcon, {style: "toolbutton"});
                with (_wildcardsChange) {
                  size = [22,22];
                  helpTip = "Special characters for replacement";
                } // END iconbutton _wildcardsChange
              }
              catch (e) { 
                var _wildcardsChange = add ("button", undefined, "@");
                with (_wildcardsChange) {
                  size = [22,23]
                  helpTip = "Special characters for replacement";
                } // END iconbutton _wildcardsChange
              } // END Icon Sonderezeichen einfuegen
            } // END group _changeGroup      
            var _changeFormatGroup = add ("group");
            with (_changeFormatGroup) {
              alignment = "right";
              margins.bottom = 0;
              margins.right = "27";
              // Icon: Refresh ChangeStyles
              try {
                var _refreshCangeStylesIcon = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x12\x00\x00\x00\x11\b\x06\x00\x00\x00\u00D0Z\u00FC\u00F9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x01=IDATx\u00DA\u00AC\u00D4=H\x03A\x10\u0086\u00E1\u00BDD4*\bZ*A\u00B1\u00B3Ke%b\u00A1\u00A0\x07\x01[\u0083\u0085\u00B5\bi\u00D2\u00A4\u00B6\u00B1\x14\x05{\x0B\x7FJA\u00B4\u00B3\u00B2S\u008BtV!\u0085\u00C4RA\u0088\x1A\u0089\u009E\u00EF\u0084\x11\u0086e\u00AF\u00F2\x16\x1E\b\u00BB\u00CBw\u00B7;sqI\u0092\u00B8\u00FF\x0E\u00C9\x18HY\u009B@\u008CyL\"\u00876\u00EEq\u00817\u00DD\u00B7\u00813\u00F9\x11IZ\x14E6d\x01;\x18\u00C5'\u009Ed\x1F\u008A\x18B\x07\x07\u0098F\x05\u00E5~\u0086\x17\u00B4\u0088\x1A\u00DEq\u008C\x1B|\u00E9\u00DA \u0096\u00B1\u0085a\u00F3\u00E0\u00B2\x7F\u00B4qlkH\x1D-\u00EF\u00B8\x12x\u00ADo\x12\u00FBwa\u0083f\u00D1\u00C3I \u00C4\u0099;\u0089C\x0B\u00FE\u00D1$X\u00CA\u00F8\x1D\u00D8+\u00F73\x17\u0098o\u00F4+\u009FU\u00F9s.\u00A3a\u00EF\u00A8\x14X\x7FD70\u009F\u00D7\u0096\u00E8\u0085\u0082v\u00BD\u00CD\u00D2h\u008D\u0094\x17X\u00C1&\u00F6\u00F1\u00E0\x07\u00D9!e>MY\u009B\u00D1^\u0092\u00D1\u00FC\u009BL\u00BB\u00A3%\u00ACi\x13:\u00D3\u0090\u00AB\u00D8\u00C3\b\u008E\u00F0\x1A*\u00FF%\u00CE\u00B5\u0087\u00AA\u00BA\u00B9\u00AB\u009FH\u00A2\u009FH\x01\x1F8\u00C4\u00AD\u00AD\u009A\r\u00AA\u0098\u00E3\u008Ca]?\u00DA)\u00FC\u00E0\x19w\u00B8\u00C2\u008B_~\u0097\u00E9\u00DFH\x16a\u00BF\x02\f\x00\u00BD/g\u00CDu\u00B8\u009C'\x00\x00\x00\x00IEND\u00AEB`\u0082";
                var _refreshChangeStyles = add ("iconbutton", undefined, _refreshCangeStylesIcon, {style: "toolbutton"});
                with (_refreshChangeStyles) {
                  size = [24,24];
                  helpTip = "Refresh character and paragraph styles";
                } // END iconbutton _refreshChangeStyles
              }
              catch (e) { 
                var _refreshChangeStyles = add ("button", undefined, "R");
                with (_refreshChangeStyles) {
                  size = [24,24];
                  graphics.font = "dialog:11";
                  helpTip = "Refresh character and paragraph styles";
                } // END button _refreshChangeStyles
              } // end Icon: Refresh ChangeStyles   
              var _changeCharacterStyles = add ("dropdownlist", undefined, _doc.characterStyles.everyItem().name);
              with (_changeCharacterStyles) {
                graphics.font = "dialog:11";
                graphics.foregroundColor = graphics.newPen (graphics.PenType.SOLID_COLOR, [0.13, 0.13, 0.13], 1);
                maximumSize.width = 165;
              } // END dropdownlist _changeCharacterStyles
              var _changeParagraphStyles = add ("dropdownlist", undefined, _doc.paragraphStyles.everyItem().name);
              with (_changeParagraphStyles) {
                graphics.font = "dialog:11";
                graphics.foregroundColor = graphics.newPen (graphics.PenType.SOLID_COLOR, [0.13, 0.13, 0.13], 1);
                maximumSize.width = 160;
              } // END dropdownlist _changeParagraphStyles
              writeStyleItems (_changeCharacterStyles, _changeParagraphStyles);
            } // END group _changeFormatGroup         
          } // END group _changePanelColumnLeft  
          var _changePanelColumnRight = add ("group");       
          with (_changePanelColumnRight) { 
            alignment = "fill";
            alignChildren = "top";
            var _changeButton = add ("button", undefined, "Change");
            with (_changeButton) {
              helpTip = "Change all matches!";
            } // END button _changeButton
          } // END group _changePanelColumnRight       
        } // END panel _changePanel         
      } // END group _columnRight
    } // END window _palette
    
    // Callbacks ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    _inputGrep.onChanging = function() { 
      __initiateSearch ();
    }

    // Sonderzeichen fuer Suche einfuegen
    _wildcardsFind.onClick = function () {     
      var _textselection = _inputGrep.textselection;
      if (_inputGrep.active == true) {   
        _inputGrep.textselection = "(?#textselection?)";
      } else {
        _inputGrep.text += "(?#textselection?)";
      }
      var _selectedWildcardForFind = __getWildcardsForFind ();     
      if (_selectedWildcardForFind!="") {
        switch (_selectedWildcardForFind) {
          case "()" :
            _textselection = "("+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;
          case "(?:)" :
            _textselection = "(?:"+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;         
          case "[]" :
            _textselection = "["+_textselection+"]";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;
          case "[^]" :
            _textselection = "[^"+_textselection+"]";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;         
          case "(?<=)" :
            _textselection = "(?<="+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;
          case "(?<!)" :
            _textselection = "(?<!"+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;
          case "(?=)" :
            _textselection = "(?="+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;
          case "(?!)" :
            _textselection = "(?!"+_textselection+")";
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            break;         
          case "(?#comment?)" :
            if (_textselection!="") {
              _textselection = "(?#"+_textselection+"?)";
              _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
            } else {
              _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_selectedWildcardForFind);
            }
            break;
          default :
            _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_selectedWildcardForFind);
        } // END switch _selectedWildcardForFind
      } else {
        _inputGrep.text = _inputGrep.text.replace(/\(\?#textselection\?\)/,_textselection);
      } 
      __initiateSearch ();
    }
    
    // Sonderzeichen fuer Ersetzung einfuegen
    _wildcardsChange.onClick = function () {          
      var _textselection = _changeGrep.textselection;
      if (_changeGrep.active == true) {   
        _changeGrep.textselection = "(?#textselection?)";
      } else {
        _changeGrep.text += "(?#textselection?)";
      }
      var _selectedWildcardForChange = __getWildcardsForChange ();
      if (_selectedWildcardForChange!="") {
        _changeGrep.text = _changeGrep.text.replace(/\(\?#textselection\?\)/,_selectedWildcardForChange);
      } else {
        _changeGrep.text = _changeGrep.text.replace(/\(\?#textselection\?\)/,_textselection);     
      } 
    }

    _findCharacterStyles.onChange = function() { 
      __initiateSearch ();
    }
  
    _findParagraphStyles.onChange = function() { 
      __initiateSearch ();
    }
  
    _places.onChange = function() { 
      __initiateSearch ();     
    } 
  
    // Initiate Search if Live-Modus is on
    function __initiateSearch () {
      _sc = 0;
      if (_live.value == true) {
        var _onChangeCondition = true;
        var _findOrChange = "find";
        _hits = _getGrep (_onChangeCondition, _findOrChange); 
        if (_hits == null) _numberOfHits.text = 0; else _numberOfHits.text = _hits; 
      } else { 
        _onChangeCondition = false;    
      }
    }
  
    _findButton.onClick = function() { 
      alertConditionalText (); 
      _sc = 0;
      var _onClickCondition = true;
      var _findOrChange = "find";
      _hits = _getGrep (_onClickCondition, _findOrChange); 
      if (_hits == null) _numberOfHits.text = 0; else _numberOfHits.text = _hits; 
    }  
  
    _changeButton.onClick = function() { 
      alertConditionalText (); 
      _sc = 0;
      var _onClickCondition = true;
      var _findOrChange = "change";
      _hits = _getGrep (_onClickCondition, _findOrChange); 
      if (_hits == null) _numberOfHits.text = 0; else _numberOfHits.text = _hits; 
    } 
  
    _copyButton.onClick = function ()  {
      app.doScript(copyButtonOnClick, ScriptLanguage.JAVASCRIPT , [], UndoModes.ENTIRE_SCRIPT, "Copy matches");
      function copyButtonOnClick () {
        var _resultStrings = [];     
        var _resultsToCopy = findHits ();   
        if (_resultsToCopy.length>0) {           
          for (var i=0; i<_resultsToCopy.length; i++) {   
            _resultStrings.push(_resultsToCopy[i].contents);        
          }   
          var _textForClipboard = _resultStrings.join("\t");
          var _firstPage = app.activeDocument.pages[0];
          try {
            var _tempLayer = app.activeDocument.layers.add({name:"::tempLayer::"});
            _tempLayer.visible = false;
            var _tempTF = app.activeDocument.textFrames.add(_tempLayer,undefined,_firstPage, {name:"::tempTF::"});
            var _firstPageBounds = _firstPage.bounds;
            _tempTF.visibleBounds = _firstPageBounds; 
            _tempTF.contents = _textForClipboard;      
            app.activeDocument.select(_tempTF.texts);
            app.copy(); 
            alert("The following matches were copied to the clipboard:\r" + _textForClipboard);
          } catch (e) { _copyFailed (); } 
          try { 
            _tempTF.remove();
            _tempLayer.remove();
          } 
          catch (e) { _copyFailed (); } 
        } else {
          _copyFailed ();
        }
       
        function _copyFailed () {
          alert("Match(es) could not be copied to the clipboard!\r" + "Possible causes:\r" + "- No match(es) in the document\r" + "- The search was not performed as yet."); 
        }
      }
    }
  
    _selectionButton.onClick = function ()  {  
      var _resultsToSelect = findHits ();
      if (_resultsToSelect.length > 0) {
        if (_sc >= _resultsToSelect.length) { 
          _sc = 0; 
        }
        try { showIt (_resultsToSelect[_sc]); } catch (e) { alert ("Match in overset text or on master pages!"); } // showIt: error with overset text
        _sc += 1;
        if (_sc >= _resultsToSelect.length && _resultsToSelect.length > 1) { alert ("You have reached the last match."); }
      } else {
        alert("No matches in document!");
      }       
    }

    _clearConditionButton.onClick = function ()  {
      _sc = 0;
      delConditions (); 
    }
  
    _refreshFindStyles.onClick = function () {  
      var _checkLiveValue = _live.value;
      if (_checkLiveValue) {
        _live.value = false;
      }
      writeStyleItems (_findCharacterStyles, _findParagraphStyles);
      _live.value = _checkLiveValue;
    }
  
    _refreshChangeStyles.onClick = function () {         
      writeStyleItems (_changeCharacterStyles, _changeParagraphStyles);
    }
  
    _exitButton.onClick = function ()  {
      delConditionsInAllDocs (); 
      _palette.close(0);
    }
  
    _palette.onClose = function () {
      _sc = 0;
      delConditionsInAllDocs ();
    }
    // end Callbacks ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
    function writeStyleItems (_cStyles, _pStyles) { 
      
      var _doc = app.activeDocument;
      with (_cStyles) {        
          removeAll();
          add ("item", "Character Style: blank", 0);
          add ("separator", undefined, 1);
          for (var i=0; i<_doc.allCharacterStyles.length; i++) { 
            var _cs = _doc.allCharacterStyles[i];
            if (_cs.parent.constructor.name == "CharacterStyleGroup") {            
              if (_cs.parent.parent.constructor.name == "CharacterStyleGroup") {
                add ("item", _cs.parent.parent.name + " > " + _cs.parent.name + " > " + _cs.name); 
                _cs.label = _cs.parent.parent.name + " > " + _cs.parent.name + " > " + _cs.name;
              } else { 
                add ("item", _cs.parent.name + " > " + _cs.name);
                _cs.label = _cs.parent.name + " > " + _cs.name;
              }
            } else {  
              add ("item", _cs.name);
              _cs.label = _cs.name;
            }
          }
          selection = 0;
        } 
      with (_pStyles) {     
        removeAll();
        add ("item", "Paragraph Style: blank", 0);
        add ("separator", undefined, 1);
        for (var j=0; j<_doc.allParagraphStyles.length; j++) {
          var _ps = _doc.allParagraphStyles[j];
          if (_ps.parent.constructor.name == "ParagraphStyleGroup") {            
            if (_ps.parent.parent.constructor.name == "ParagraphStyleGroup") {
              add ("item", _ps.parent.parent.name + " > " + _ps.parent.name + " > " + _ps.name); 
              _ps.label = _ps.parent.parent.name + " > " + _ps.parent.name + " > " + _ps.name;
            } else { 
              add ("item", _ps.parent.name + " > " + _ps.name);
              _ps.label = _ps.parent.name + " > " + _ps.name;
            }
          } else {  
              add ("item", _ps.name);
              _ps.label = _ps.name;
          }  
        }
        selection = 0;
      }
    }
  
    function __getWildcardsForFind() {

      // Wildcard Object for Search
      var _wildcardsForFind = {
        "Tab Character": "\\t", 
        "Forced Line Break": "\\n",
        "End of Paragraph": "\\r",
        "Space (Defined by the font)":"[ ]",
        "Bullet Character":"~8",
        "Backslash Character":"\\\\",
        "Caret Character":"\\^",
        "Copyright Symbol":"~2",
        "Ellipsis":"~e",
        "Paragraph Symbol":"~7",
        "Registered Trademark Symbol":"~r",
        "Section Symbol":"~6",
        "Trademark Symbol":"~d",
        "Open Parenthesis Character":"\\(",
        "Close Parenthesis Character":"\\)",
        "Open Brace Character":"\\{",
        "Close Brace Character":"\\}",
        "Open Bracket Character":"\\[",
        "Close Bracket Character":"\\]",
        "Any Page Number":"~#",
        "Current Page Number":"~N",
        "Next Page Number":"~X",
        "Previous Page Number":"~V",
        "Section Marker":"~x",
        "Anchored Object Marker":"~a",
        "Footnote Reference Marker":"~F",
        "Index Marker":"~I",
        "End Nested Style Here":"~h",
        "Em Dash":"~_",
        "En Dash":"~=",
        "Hyphen":"\\-",
        "Discretionary Hyphen":"~-",
        "Nonbreaking Hyphen":"~~",
        "Em Space":"~m",
        "En Space":"~>",
        "Third Space":"~3",
        "Quarter Space":"~4",
        "Sixth Space":"~%",
        "Thin Space":"~<",
        "Flush Space":"~f",
        "Hair Space":"~|",
        "Nonbreaking Space":"~S",
        "Nonbreaking Space (fixed width)":"~s",
        "Punctuation Space":"~.",
        "Figure Space":"~/",
        "Any Double Quotation Mark":"\"",
        "Any Single Quotation Mark (Apostrophe)":"\'",
        "Straight Double Quotation Mark":"~\"",
        "Double Left Quotation Mark":"~{",
        "Double Right Quotation Mark":"~}",
        "Straight Single Quotation Mark (Apostrophe)":"~\'",
        "Single Left Quotation Mark":"~[",
        "Single Right Quotation Mark":"~]",
        "All Break Character (except Forced Line Break)":"\\r",
        "Standard carriage return":"~b",
        "Column Break":"~M",
        "Frame Break":"~R",
        "Page Break":"~P",
        "Odd Page Break":"~L",
        "Even Page Break":"~E",
        "Discretionary Line Break":"~k",
        "Any Variable":"~v",
        "Running header (paragraph style) variable":"~Y",
        "Running header (character style) variable":"~Z",
        "Custom text variable":"~u",
        "Any Page Number":"~#",
        "Automatic Page Number":"~N",
        "Next Page Number":"~X",
        "Previous Page Number":"~V",
        "Last page number variable":"~T",
        "Chapter number variable":"~H",
        "Creation date variable":"~O",
        "Modification date variable":"~o",
        "Output date variable":"~D",
        "File name variable":"~l",
        "Metadata Labeling":"~J",
        "Right Indent Tab":"~y",
        "Indent to Here":"~i",
        "End Nested Style Here":"~h",
        "Nonjoiner":"~j",
        "Any Digit":"\\d",
        "Any character that is not a digit":"\\D",
        "Any Letter":"[\\u\\l]",
        "Any Character":".",
        "Any Character (inclusive all Break Character)":"\\X",
        "White Space (any space or tab)":"\\s",
        "Any character that is not a white space":"\\S",
        "Any word character":"\\w",
        "Any character that is not a word character":"\\W",
        "Any uppercase letter":"\\u",
        "Any character that is not an uppercase letter":"\\U",
        "Any lowercase letter":"\\l",
        "Any character that is not a lowercase letter":"\\L",
        "All Break Character (except Forced Line Break)":"\\r",
        "Character Set":"[]",
        "Negate Own Character Set":"[^]",
        "Unicode-Codepoint":"\\x{####}",
        "Unicode-Name 1":"\\N{Unicode-Name}",
        "Unicode-Name 2":"[[.Unicode-Name.]]",
        "Beginning of paragraph":"^",
        "End of Paragraph":"$",
        "Beginning of Word":"\\<",
        "End of Word":"\\>",
        "Word Boundary":"\\b",
        "Opposite of Word Boundary":"\\B",
        "Beginning of Story":"\\A",
        "End of Story":"\\Z",
        "Zero or One Time":"?",
        "Zero or More Times":"*",
        "One or More Times":"+",
        "Zero or One Time (Shortest Match)":"??",
        "Zero or More Times (Shortest Match)":"*?",
        "One or More Times (Shortest Match)":"+?",
        "n times":"{n}",
        "at least n times more than m times":"{n,m}",
        "n or more times":"{n,}",
        "n or more times (Shortest Match)":"{n,m}?",
        "Marking Subexpression":"()",
        "Non-marking Subexpression (Do not mark match)":"(?:)",
        "Class of characters":"[]",
        "Or":"|",
        "Positive Lookbehind":"(?<=)",
        "Negative Lookbehind":"(?<!)",
        "Positive Lookahead":"(?=)",
        "Negative Lookahead":"(?!)",
        "Case-insensitive On":"(?i)",
        "Case-insensitive Off":"(?-i)",
        "Multiline On":"(?m)",
        "Multiline Off":"(?-m)",
        "Single-line On":"(?s)",
        "Single-line Off":"(?-s)",
        "Ignore spaces in the expression":"(?x)",
        "Do not ignore spaces in the expression":"(?-x)",
        "Comment":"(?#comment?)",
        "Any alphanumeric character":"[[:alnum:]]",
        "Any alphabetic character":"[[:alpha:]]",
        "Any blank character (either space or tab)":"[[:blank:]]",
        "Numbers":"[[:digit:]]",
        "lower-case character":"[[:lower:]]",
        "upper-case character":"[[:upper:]]",
        "Any punctuation character":"[[:punct:]]",
        "Any graphical character":"[[:graph:]]",
        "Blanks":"[[:space:]]",
        "Word Character":"[[:word:]]",
        "Any hexadecimal digit character":"[[:xdigit:]]",
        "Any character of a certain glyph set":"[[=a=]]",
        "letter":"\\p{L*}",
        "lowercase_letter":"\\p{Ll}",
        "uppercase_letter":"\\p{Lu}",
        "titlecase_letter":"\\p{Lt}",
        "modifier_letter":"\\p{Lm}",
        "letter_other":"\\p{Lo}",
        "separator":"\\p{Z*}",
        "space_separator":"\\p{Zs}",
        "line_separator (XML-Export)":"\\p{Zl}",
        "paragraph-separator (XML-Export)":"\\p{Zp}",
        "symbol":"\\p{S*}",
        "math_symbol":"\\p{Sm}",
        "currency_symbol":"\\p{Sc}",
        "modifier_symbol":"\\p{Sk}",
        "other_symbol":"\\p{So}",
        "number":"\\p{N*}",
        "decimal_digit_number":"\\p{Nd}",
        "letter_number":"\\p{Nl}",
        "other_numbers":"\\p{No}",
        "punctation":"\\p{P*}",
        "dash_punctuation":"\\p{Pd}",
        "open_puntuation":"\\p{Ps}",
        "close_punctuation":"\\p{Pe}",
        "initial_punctuation":"\\p{Pi}",
        "final_punctuation":"\\p{Pf}",
        "other_punctuation":"\\p{Po}"
      }

      // Wildcards Dialog for Search
      var _selectWildcardsForFind = new Window ("dialog","Wildcards for Search");
      with (_selectWildcardsForFind) {
        alignChildren = "right";
        var _wildcardsForFindTree = add ("treeview");
        with (_wildcardsForFindTree) {
          preferredSize = [380,430];
          itemSize = [560,20];
          add ("item","Tab Character"); 
          add ("item","Forced Line Break");
          add ("item","End of Paragraph");

          var _symbols = add ("node", "Symbols");
          with (_symbols) {
            add ("item","Space (Defined by the font)");
            add ("item","Bullet Character");
            add ("item","Backslash Character");
            add ("item","Caret Character");
            add ("item","Copyright Symbol");
            add ("item","Ellipsis");
            add ("item","Paragraph Symbol");
            add ("item","Registered Trademark Symbol");
            add ("item","Section Symbol");
            add ("item","Trademark Symbol");
            add ("item","Open Parenthesis Character");
            add ("item","Close Parenthesis Character");
            add ("item","Open Brace Character");
            add ("item","Close Brace Character");
            add ("item","Open Bracket Character");
            add ("item","Close Bracket Character");
          }
          // Marken
          var _marks = add ("node","Marks");
          with (_marks) {
            add ("item","Any Page Number");
            add ("item","Current Page Number");
            add ("item","Next Page Number");
            add ("item","Previous Page Number");
            add ("item","Section Marker");
            add ("item","Anchored Object Marker");
            add ("item","Footnote Reference Marker");
            add ("item","Index Marker");
            add ("item","End Nested Style Here");
          }
          // Trenn- und Gedankenstriche
          var _dashes = add ("node","Hyphens and Dashes");
          with (_dashes) {
            add ("item","Em Dash");
            add ("item","En Dash");
            add ("item","Hyphen");
            add ("item","Discretionary Hyphen");
            add ("item","Nonbreaking Hyphen");
          }
          // Leerraum
          var _spaces = add ("node","Spaces");
          with (_spaces) {
            add ("item","Em Space");
            add ("item","En Space");
            add ("item","Third Space");
            add ("item","Quarter Space");
            add ("item","Sixth Space");
            add ("item","Thin Space");
            add ("item","Flush Space");
            add ("item","Hair Space");
            add ("item","Nonbreaking Space");
            add ("item","Nonbreaking Space (fixed width)");
            add ("item","Punctuation Space");
            add ("item","Figure Space");
          }
          // Anführungszeichen
          var _puntuation = add ("node","Quotation Marks");
          with (_puntuation) {
            add ("item","Any Double Quotation Mark");
            add ("item","Any Single Quotation Mark (Apostrophe)");
            add ("item","Straight Double Quotation Mark");
            add ("item","Double Left Quotation Mark");
            add ("item","Double Right Quotation Mark");
            add ("item","Straight Single Quotation Mark (Apostrophe)");
            add ("item","Single Left Quotation Mark");
            add ("item","Single Right Quotation Mark");
          }
          // Umbruchzeichen
          var _breaks = add ("node","Break Characters");
          with (_breaks) {
            add ("item","All Break Character (except Forced Line Break)");
            add ("item","Standard carriage return");
            add ("item","Column Break");
            add ("item","Frame Break");
            add ("item","Page Break");
            add ("item","Odd Page Break");
            add ("item","Even Page Break");
            add ("item","Discretionary Line Break");
          }
          // Variable
          var _variables = add ("node","Variables");
          with (_variables) {
            add ("item","Any Variable");
            add ("item","Running header (paragraph style) variable");
            add ("item","Running header (character style) variable");
            add ("item","Custom text variable");
            add ("item","Any Page Number");
            add ("item","Automatic Page Number");
            add ("item","Next Page Number");
            add ("item","Previous Page Number");
            add ("item","Last page number variable");
            add ("item","Chapter number variable");
            add ("item","Creation date variable");
            add ("item","Modification date variable");
            add ("item","Output date variable");
            add ("item","File name variable");
            add ("item","Metadata Labeling");
          }
          // Andere 
          var _others = add ("node","Other");
          with (_others) {
            add ("item","Right Indent Tab");
            add ("item","Indent to Here");
            add ("item","End Nested Style Here");
            add ("item","Nonjoiner");
          }
          // Platzhalter
          var _placeholders = add ("node","Placeholder");
          with (_placeholders) {
            add ("item","Any Digit");
            add ("item","Any character that is not a digit");
            add ("item","Any Letter");
            add ("item","Any Character");
            add ("item","Any Character (inclusive all Break Character)");
            add ("item","White Space (any space or tab)");
            add ("item","Any character that is not a white space");
            add ("item","Any word character");
            add ("item","Any character that is not a word character");
            add ("item","Any uppercase letter");
            add ("item","Any character that is not an uppercase letter");
            add ("item","Any lowercase letter");
            add ("item","Any character that is not a lowercase letter");
            add ("item","All Break Character (except Forced Line Break)");
          }
          // Eigene Zeichenklasse
          var _characterClass = add ("node","Own Character Set");
          with (_characterClass) {
            add ("item","Character Set");
            add ("item","Negate Own Character Set");
          }
          // Unicode
          var _unicode = add ("node","Unicode");
          with (_unicode) {
            add ("item","Unicode-Codepoint");
            add ("item","Unicode-Name 1");
            add ("item","Unicode-Name 2");
          }
          // Positionen
          var _position = add ("node","Locations");
          with (_position) {
            add ("item","Beginning of paragraph");
            add ("item","End of Paragraph");
            add ("item","Beginning of Word");
            add ("item","End of Word");
            add ("item","Word Boundary");
            add ("item","Opposite of Word Boundary");
            add ("item","Beginning of Story");
            add ("item","End of Story");
          }
          // Wiederholung
          var _repeatings = add ("node","Repetitions");
          with (_repeatings) {
            add ("item","Zero or One Time");
            add ("item","Zero or More Times");
            add ("item","One or More Times");
            add ("item","Zero or One Time (Shortest Match)");
            add ("item","Zero or More Times (Shortest Match)");
            add ("item","One or More Times (Shortest Match)");
            add ("item","n times");
            add ("item","at least n times more than m times");
            add ("item","n or more times");
            add ("item","n or more times (Shortest Match)");
          }
          // Entsprechung
          var _equivalents = add ("node","Matches");
          with (_equivalents) {
            add ("item","Marking Subexpression");
            add ("item","Non-marking Subexpression (Do not mark match)");
            add ("item","Class of characters");
            add ("item","Or");
            add ("item","Positive Lookbehind");
            add ("item","Negative Lookbehind");
            add ("item","Positive Lookahead");
            add ("item","Negative Lookahead");
          }
          // Modifizierer
          var _modifier = add ("node","Modifiers");
          with (_modifier) {
            add ("item","Case-insensitive On");
            add ("item","Case-insensitive Off");
            add ("item","Multiline On");
            add ("item","Multiline Off");
            add ("item","Single-line On");
            add ("item","Single-line Off");
            add ("item","Ignore spaces in the expression");
            add ("item","Do not ignore spaces in the expression");
            add ("item","Comment");
          }
          // Posix-Ausdrücke
          var _posix = add ("node","POSIX");
          with (_posix) {
            add ("item","Any alphanumeric character");
            add ("item","Any alphabetic character");
            add ("item","Any blank character (either space or tab)");
            add ("item","Numbers");
            add ("item","lower-case character");
            add ("item","upper-case character");
            add ("item","Any punctuation character");
            add ("item","Any graphical character");
            add ("item","Blanks");
            add ("item","Word Character");
            add ("item","Any hexadecimal digit character");
            add ("item","Any character of a certain glyph set");
          }
          // Unicode-Properties
          var _unicodeProps = add ("node","Unicode Properties");
          with (_unicodeProps) { 
            add ("item","letter");
            add ("item","lowercase_letter");
            add ("item","uppercase_letter");
            add ("item","titlecase_letter");
            add ("item","modifier_letter");
            add ("item","letter_other");
            add ("item","separator");
            add ("item","space_separator");
            add ("item","line_separator (XML-Export)");
            add ("item","paragraph-separator (XML-Export)");
            add ("item","symbol");
            add ("item","math_symbol");
            add ("item","currency_symbol");
            add ("item","modifier_symbol");
            add ("item","other_symbol");
            add ("item","number");
            add ("item","decimal_digit_number");
            add ("item","letter_number");
            add ("item","other_numbers");
            add ("item","punctation");
            add ("item","dash_punctuation");
            add ("item","open_puntuation");
            add ("item","close_punctuation");
            add ("item","initial_punctuation");
            add ("item","final_punctuation");
            add ("item","other_punctuation");
          }   
        } // END tree _wildcardsForFindTree
      
        var _buttonGroup = add ("group");
        with (_buttonGroup) {
          var _close = add ("button", undefined, "Close", {name: "cancel"});
          var _insert = add ("button", undefined, "Insert", {name: "ok"});     
        }
      } // END dialog _selectWildcardsForFind
      
      var _insertWildcardForFind = _selectWildcardsForFind.show ();

      if (_insertWildcardForFind == 1 && _wildcardsForFindTree.selection != null && _wildcardsForFind[_wildcardsForFindTree.selection.text]!=null) {
        return _wildcardsForFind[_wildcardsForFindTree.selection.text]; 
      } else {
        return "";
      }
    } // END function __getWildcardsForFind
  
  
    function __getWildcardsForChange() {
  
      // Wildcard Object for Change
      var _wildcardsForChange = {
        "Tab Character": "\\t", 
        "Forced Line Break": "\\n",
        "End of Paragraph": "\\r",
        "Bullet Character":"~8",
        "Caret Character":"\\^",
        "Copyright Symbol":"~2",
        "Ellipsis":"~e",
        "Paragraph Symbol":"~7",
        "Registered Trademark Symbol":"~r",
        "Section Symbol":"~6",
        "Trademark Symbol":"~d",
        "Current Page Number":"~N",
        "Next Page Number":"~X",
        "Previous Page Number":"~V",
        "Section Marker":"~x",
        "Em Dash":"~_",
        "En Dash":"~=",
        "Hyphen":"\\-",
        "Discretionary Hyphen":"~-",
        "Nonbreaking Hyphen":"~~",
        "Em Space":"~m",
        "En Space":"~>",
        "Third Space":"~3",
        "Quarter Space":"~4",
        "Sixth Space":"~%",
        "Thin Space":"~<",
        "Flush Space":"~f",
        "Hair Space":"~|",
        "Nonbreaking Space":"~S",
        "Nonbreaking Space (fixed width)":"~s",
        "Punctuation Space":"~.",
        "Figure Space":"~/",
        "Double Quotation Mark":"~\"",
        "Double Left Quotation Mark":"~{",
        "Double Right Quotation Mark":"~}",
        "Straight Single Quotation Mark (Apostrophe)":"~\'",
        "Single Left Quotation Mark":"~[",
        "Single Right Quotation Mark":"~]",
        "Standard carriage return":"~b",
        "Column Break":"~M",
        "Frame Break":"~R",
        "Page Break":"~P",
        "Odd Page Break":"~L",
        "Even Page Break":"~E",
        "Discretionary Line Break":"~k", 
        "Right Indent Tab":"~y",
        "Indent to Here":"~i",
        "End Nested Style Here":"~h",
        "Nonjoiner":"~j",
        "Clipboard Contents (Formatted)":"~c",
        "Clipboard Contents (Unformatted)":"~C",
        "Found Text":"$$0",
        "Found Text 1":"$$1",
        "Found Text 2":"$$2",
        "Found Text 3":"$$3",
        "Found Text 4":"$$4",
        "Found Text 5":"$$5",
        "Found Text 6":"$$6",
        "Found Text 7":"$$7",
        "Found Text 8":"$$8",
        "Found Text 9":"$$9"
      }
      
      // Wildcards Dialog for Change
      var _selectWildcardsForChange = new Window ("dialog","Wildcards for Change");
      with (_selectWildcardsForChange) {
        alignChildren = "right";
        var _wildcardsForChangeTree = add ("treeview");
        with (_wildcardsForChangeTree) {
          preferredSize = [350,260];
          itemSize = [560,20];
          
          add ("item","Tab Character"); 
          add ("item","Forced Line Break");
          add ("item","End of Paragraph");

          // Symbole
          var _symbols = add ("node", "Symbols");
          with (_symbols) {
            add ("item","Bullet Character");
            add ("item","Caret Character");
            add ("item","Copyright Symbol");
            add ("item","Ellipsis");
            add ("item","Paragraph Symbol");
            add ("item","Registered Trademark Symbol");
            add ("item","Section Symbol");
            add ("item","Trademark Symbol");
          } 

          // Marken
          var _marks = add ("node","Marks");
          with (_marks) {
            add ("item","Current Page Number");
            add ("item","Next Page Number");
            add ("item","Previous Page Number");
            add ("item","Section Marker");
          }

          // Trenn- und Gedankenstriche
          var _dashes = add ("node","Hyphens and Dashes");
          with (_dashes) {
            add ("item","Em Dash");
            add ("item","En Dash");
            add ("item","Hyphen");
            add ("item","Discretionary Hyphen");
            add ("item","Nonbreaking Hyphen");
          }

          // Leerraum
          var _spaces = add ("node","Spaces");
          with (_spaces) {
            add ("item","Em Space");
            add ("item","En Space");
            add ("item","Third Space");
            add ("item","Quarter Space");
            add ("item","Sixth Space");
            add ("item","Thin Space");
            add ("item","Flush Space");
            add ("item","Hair Space");
            add ("item","Nonbreaking Space");
            add ("item","Nonbreaking Space (fixed width)");
            add ("item","Punctuation Space");
            add ("item","Figure Space");
          }

          // Anführungszeichen
          var _puntuation = add ("node","Quotation Mark");
          with (_puntuation) {
            add ("item","Double Quotation Mark");
            add ("item","Double Left Quotation Mark");
            add ("item","Double Right Quotation Mark");
            add ("item","Straight Single Quotation Mark (Apostrophe)");
            add ("item","Single Left Quotation Mark");
            add ("item","Single Right Quotation Mark");
          }

          // Umbruchzeichen
          var _breaks = add ("node","Break");
          with (_breaks) {
            add ("item","Standard carriage return");
            add ("item","Column Break");
            add ("item","Frame Break");
            add ("item","Page Break");
            add ("item","Odd Page Break");
            add ("item","Even Page Break");
            add ("item","Discretionary Line Break");
          }

          // Andere
          var _others = add ("node","Others");
          with (_others) { 
            add ("item","Right Indent Tab");
            add ("item","Indent to Here");
            add ("item","End Nested Style Here");
            add ("item","Nonjoiner");
            add ("item","Clipboard Contents (Formatted)");
            add ("item","Clipboard Contents (Unformatted)");
          }

          // Gefunden
          var _searchResults = add ("node","Found");
          with (_searchResults) {
            add ("item","Found Text");
            add ("item","Found Text 1");
            add ("item","Found Text 2");
            add ("item","Found Text 3");
            add ("item","Found Text 4");
            add ("item","Found Text 5");
            add ("item","Found Text 6");
            add ("item","Found Text 7");
            add ("item","Found Text 8");
            add ("item","Found Text 9");
          }            
        } // END tree _wildcardsForChangeTree
      
        var _buttonGroup = add ("group");
        with (_buttonGroup) {
          var _close = add ("button", undefined, "Close", {name: "cancel"});
          var _insert = add ("button", undefined, "Insert", {name: "ok"});     
        }
      } // END dialog _selectWildcardsForChange
      
      var _insertWildcardForChange = _selectWildcardsForChange.show ();

      if (_insertWildcardForChange == 1 && _wildcardsForChangeTree.selection != null && _wildcardsForChange[_wildcardsForChangeTree.selection.text]!=null) {
        return _wildcardsForChange[_wildcardsForChangeTree.selection.text]; 
      } else {
        return "";
      }  
    } // END function __getWildcardsForChange
  

    function _getGrep (_condition, _findOrChange) { 
      
      // Hervorhebung (bedingeter Text) ist im Vorschau-Modus nicht sichtbar 
      app.activeDocument.layoutWindows[0].screenMode = ScreenModeOptions.previewOff;
      
      var _doc = app.activeDocument;
      var _input = _inputGrep.text;
      var _change = _changeGrep.text;
      var _place = _places.selection.text;
      
      switch (_place) {
        case "Story" :
            try {
              _place = _doc.selection[0].insertionPoints[0].parentStory;
            } catch(e) { _place = null; /*alert("Place, Zuordnung, Textabschnitt: " + e + "Zeile: " + e.line);*/ }        
          break;
        case "Text Frame" :
          try {
            _place = _doc.selection[0].insertionPoints[0].parentTextFrames[0];
          } catch(e) { _place = null; /*alert("Place, Zuordnung, Textrahmen: " + e + "Zeile: " + e.line);*/ }
          break;
        case "Tables" :
          try {
            _place = _doc.stories.everyItem().tables.everyItem();
          } catch(e) { _place = null; /*alert("Place, Zuordnung, Tabellen: " + e + "Zeile: " + e.line);*/ }
          break;
        case "Selection" :
          if (((app.selection.length > 0)&&(app.selection[0].constructor.name != "InsertionPoint"))&&
              ((app.selection[0].hasOwnProperty ("baseline"))||(app.selection[0].constructor.name == "TextFrame")||(app.selection[0].constructor.name == "Table"))) {    
            try {
              _place = app.selection[0];
            } catch(e) { _place = null; /*alert("Place, Zuordnung, Auswahl: " + e + "Zeile: " + e.line);*/ }
          } else { _place = null; } 
          break;      
        default :
          _place = _doc;
      }    
      
      if (_condition && (_place != null)) {
        var _findCharacterStyle = _findCharacterStyles.selection.text;
        if (_findCharacterStyle == "Character Style: blank") {
          _findCharacterStyle = "";
        } else {
          if (app.activeDocument.characterStyles.itemByLabel(_findCharacterStyle)!=null) {
            _findCharacterStyle = app.activeDocument.characterStyles.itemByLabel(_findCharacterStyle);
          } else {
            alert ("Character style \"" + _findCharacterStyle + "\" is not available (anymore)!\rPlease update the styles by clicking on the refresh button.");
            _findCharacterStyle = "";       
          }  
        }
        var _findParagraphStyle = _findParagraphStyles.selection.text;
        if (_findParagraphStyle == "Paragraph Style: blank") {
          _findParagraphStyle = "";
        } else {
          if (app.activeDocument.paragraphStyles.itemByLabel(_findParagraphStyle)!=null) {
            _findParagraphStyle = app.activeDocument.paragraphStyles.itemByLabel(_findParagraphStyle);  
          } else {
            alert ("Paragraph style \"" + _findParagraphStyle + "\" is not available (anymore)!\rPlease update the styles by clicking on the refresh button.");
            _findParagraphStyle = "";  
          }
        }        
        if (_findOrChange == "change") {
          var _changeCharacterStyle = _changeCharacterStyles.selection.text;
          if (_changeCharacterStyle == "Character Style: blank") {
            _changeCharacterStyle = "";
          } else {    
            if (app.activeDocument.characterStyles.itemByLabel(_changeCharacterStyle)!=null) {
              _changeCharacterStyle = app.activeDocument.characterStyles.itemByLabel(_changeCharacterStyle);
            } else {
              alert ("Character style \"" + _changeCharacterStyle + "\" is not available (anymore)!\rPlease update the styles by clicking on the refresh button.");
              _changeCharacterStyle = _findCharacterStyle; 
            }  
          }
          var _changeParagraphStyle = _changeParagraphStyles.selection.text;
          if (_changeParagraphStyle == "Paragraph Style: blank") {
            _changeParagraphStyle = "";
          } else {
            if (app.activeDocument.paragraphStyles.itemByLabel(_changeParagraphStyle)!=null) {
             _changeParagraphStyle = app.activeDocument.paragraphStyles.itemByLabel(_changeParagraphStyle); 
            } else {
              alert ("Paragraph style \"" + _changeParagraphStyle + "\" is not available (anymore)!\rPlease update the styles by clicking on the refresh button.");
              _changeParagraphStyle = _findParagraphStyle;  
            }  
          } 
        } else {   
          _change = "";
          _changeCharacterStyle = "";
          _changeParagraphStyle = ""; 
        }
        
        _searchOption = [_hiddenLayers.value, _masterPages.value, _footnotes.value];
        
        if ((_input != "")||(_findCharacterStyle!= "")||(_findParagraphStyle!= "")) {
          var _hits = findChangeGrep (_findOrChange, _input, _change, _findCharacterStyle, _changeCharacterStyle, _findParagraphStyle, _changeParagraphStyle, _place, _searchOption);
        } else {
          delConditions ();
        }
      } else {
        delConditions (); 
      }
      return _hits;
    }
  } // end if _palette==null /* refresh UI */ 
  return _palette;
}


function findChangeGrep (_findOrChange, _grep, _change, _findCharacterStyle, _changeCharacterStyle, _findParagraphStyle, _changeParagraphStyle, _place, _searchOption) {
  
  var _doc = app.activeDocument;
  var _hits = 0;
  
  if (_doc.conditions.itemByName("::Highlight_GREP::").isValid) {
    _highlightColor = _doc.conditions.itemByName("::Highlight_GREP::").indicatorColor;
    _highlightMethod = _doc.conditions.itemByName("::Highlight_GREP::").indicatorMethod;
  }  
  
  delConditions ();

  if (!_doc.conditions.itemByName("::Highlight_GREP::").isValid) {
    _doc.conditions.add ({name: "::Highlight_GREP::", indicatorColor: _highlightColor, indicatorMethod: _highlightMethod});
  }
  
  var _highlightCondition = [_doc.conditions.itemByName ("::Highlight_GREP::")]; 
  var _findChangeResults = findChange (_findOrChange, _grep, _change, _findCharacterStyle, _changeCharacterStyle, _findParagraphStyle, _changeParagraphStyle, _place, _highlightCondition, _searchOption);

  if ((_findChangeResults.length > 0) && (_findChangeResults[0].constructor.name == "Array")) { 
    var _hitcounter = 0;
    for (var i=0; i<_findChangeResults.length; i++) {
      for (var j=0; j<_findChangeResults[i].length; j++) {
        _hitcounter += 1;
      }   
    }    
    _hits = _hitcounter;   
  } else { 
    _hits = _findChangeResults.length;
  }  
  return _hits; 
}


function delConditions () {
  
  if (app.activeDocument.conditions.itemByName("::Highlight_GREP::").isValid) {
    app.activeDocument.conditions.itemByName("::Highlight_GREP::").remove ();
  }
}


function delConditionsInAllDocs () {
  
  for (var d = 0; d < app.documents.length; d++) {
    if (app.documents[d].conditions.itemByName("::Highlight_GREP::").isValid) {
      app.documents[d].conditions.itemByName("::Highlight_GREP::").remove ();
    }
  }
}


function findChange (_findOrChange, _find, _change, _findCharacterStyle, _changeCharacterStyle, _findParagraphStyle, _changeParagraphStyle, _place, _highlightCondition, _searchOption) {
  
  with (app) {   
    with (findChangeGrepOptions) {   
      //User-Einstellungen speichern
      var _userIncludeFootnotes = includeFootnotes;
      var _userIncludeHiddenLayers = includeHiddenLayers;
      var _userIncludeLockedLayersForFind = includeLockedLayersForFind;
      var _userIncludeLockedStoriesForFind = includeLockedStoriesForFind;
      var _userIncludeMasterPages = includeMasterPages;
      //Einstellungen setzen
      includeFootnotes = _searchOption[2];
      includeHiddenLayers = _searchOption[0];
      includeLockedLayersForFind = false; 
      includeLockedStoriesForFind = false; 
      includeMasterPages = _searchOption[1];     
    }  
  
    findGrepPreferences = NothingEnum.nothing;
    changeGrepPreferences = NothingEnum.nothing;
    
    with (findGrepPreferences) {
      findWhat = _find;
      appliedCharacterStyle = _findCharacterStyle;
      appliedParagraphStyle = _findParagraphStyle;
    }
    
    with (changeGrepPreferences) {
      changeTo = _change;  
      appliedCharacterStyle = _changeCharacterStyle;
      appliedParagraphStyle = _changeParagraphStyle;      
      changeConditionsMode = ChangeConditionsModes.ADD_TO; 
      if (_findOrChange == "change" && _change == "") {
        appliedConditions = NothingEnum.nothing;
      } else {
        appliedConditions = _highlightCondition; 
      }    
    }
     
    try {
      _results = _place.changeGrep(true);  
    } catch(e) { 
      /*alert("Place, changeGrep: " + e + "Zeile: " + e.line);*/ 
    }    
    
    findGrepPreferences = NothingEnum.nothing;
    changeGrepPreferences = NothingEnum.nothing;
    
    with (findChangeGrepOptions) {     
      //User-Einstellungen wieder herstellen
      includeFootnotes = _userIncludeFootnotes;
      includeHiddenLayers = _userIncludeHiddenLayers;
      includeLockedLayersForFind = _userIncludeLockedLayersForFind;
      includeLockedStoriesForFind = _userIncludeLockedStoriesForFind;
      includeMasterPages = _userIncludeMasterPages;    
    } 
  }
  return _results;
}

function findHits () {
  
  var _place = app.activeDocument;
  var _highlightCondition;
  var _results = [];
  if (app.activeDocument.conditions.itemByName("::Highlight_GREP::").isValid) {
    _highlightCondition = [app.activeDocument.conditions.itemByName("::Highlight_GREP::")];
  } else {
    _highlightCondition = NothingEnum.nothing;
  } 

  with (app) {   
    with (findChangeGrepOptions) {   
      //User-Einstellungen speichern
      var _userIncludeFootnotes = includeFootnotes;
      var _userIncludeHiddenLayers = includeHiddenLayers;
      var _userIncludeLockedLayersForFind = includeLockedLayersForFind;
      var _userIncludeLockedStoriesForFind = includeLockedStoriesForFind;
      var _userIncludeMasterPages = includeMasterPages;
      //Einstellungen setzen
      includeFootnotes = true;
      includeHiddenLayers = true;
      includeLockedLayersForFind = true;
      includeLockedStoriesForFind = true;
      includeMasterPages = true;     
    }  
  
    findGrepPreferences = NothingEnum.nothing;
    changeGrepPreferences = NothingEnum.nothing;  
    
    with (findGrepPreferences) {
      appliedConditions = _highlightCondition;
    }
     
    try {
      _results = _place.findGrep();  
    } catch(e) { 
      /*alert("Place, findGrep: " + e + "Zeile: " + e.line);*/ 
    }    
    
    findGrepPreferences = NothingEnum.nothing;
    changeGrepPreferences = NothingEnum.nothing;
    
    with (findChangeGrepOptions) {     
      //User-Einstellungen wieder herstellen
      includeFootnotes = _userIncludeFootnotes;
      includeHiddenLayers = _userIncludeHiddenLayers;
      includeLockedLayersForFind = _userIncludeLockedLayersForFind;
      includeLockedStoriesForFind = _userIncludeLockedStoriesForFind;
      includeMasterPages = _userIncludeMasterPages;    
    } 
  }
  return _results;
}


// function filePath by Peter Kahrel -- www.kahrel.plus.com 
function filePath () {
	try {return File (app.activeScript).path}
    catch(e) {return File (e.fileName).path}
	}

  
// function showIt von Gregor Fellenz: www.indd-skript.de
// showIt() zeigt das übergebene Objekt an
function showIt (_object) {
	if (_object != null && app.documents.length > 0 && app.layoutWindows.length > 0 ) {
		app.activeWindow.activeSpread = getSpreadByObject (_object);
		app.select(_object);
		var myZoom = app.activeWindow.zoomPercentage; 
		app.activeWindow.zoom(ZoomOptions.showPasteboard); 
		app.activeWindow.zoomPercentage = myZoom;
		return true;
	}
	else {
		return false;
	}
}


// function getSpreadByObject von Gregor Fellenz: www.indd-skript.de
// Liefert den Druckbogen, auf dem sich das Objekt befindet
function  getSpreadByObject (_object) {
	if (_object != null) {
		_object = _object.getElements ()[0]; // Problems with Baseclass Objects like PageItem in  CS5!
		if (_object.hasOwnProperty("baseline")) {
			_object = _object.parentTextFrames[0];
		}
		while (_object != null) {
			var whatIsIt = _object.constructor;
			switch (whatIsIt) {
				case Spread : return _object;
				case Character : _object = _object.parentTextFrames[0]; break;
				case Footnote :; // drop through
				case Cell : _object = _object.insertionPoints[0].parentTextFrames[0]; break;
				case Note : _object = _object.storyOffset.parentTextFrames[0]; break;
				case XMLElement : if (_object.insertionPoints[0] != null) { _object = _object.insertionPoints[0].parentTextFrames[0]; break; }
				case Application : return null;
				default: _object = _object.parent;
			}
			if (_object == null) return null;
		}
		return _object;
			} 
	else {
		return null;
	}
}


// Neue Methode "itemByLabel" fuer CharacterStyles und ParagraphStyles
function prototypeItemByLabel () {

  Object.prototype.itemByLabel=function(_label) { 
      
    var _styles = [];
    var _result = null;
    
    switch (this.constructor.name) {
      case "CharacterStyles" :
        _styles = app.activeDocument.allCharacterStyles;
        break;
      case "ParagraphStyles" :
        _styles = app.activeDocument.allParagraphStyles;
        break;
      default :
        _result = null;
    }
      
    for (var i=0; i<_styles.length; i++) {    
      if (_styles[i].label == _label) {
        _result = _styles[i];
      }     
    }     
    return _result; 
  } 
}


// Warnmeldung falls im Dokument bereits Bedingungen fuer bedingten Text vorhanden sind.
function alertConditionalText () {  
  do {
  if (_alertCounter == true && _lastDoc == app.activeDocument) break;
  if (app.activeDocument.conditions.length == 0) break;
  if (app.activeDocument.conditions.length == 1 && app.activeDocument.conditions.itemByName("::Highlight_GREP::").isValid) break; 
  var _continue = confirm ("Caution! You already use \"Conditional Text\" in your document.\r\rIn certain cases, these conditions can be overwritten by this script.\r\rContinue Anyway?");
  _alertCounter = true;
  _lastDoc = app.activeDocument.getElements()[0];
  if (!_continue) exit();
  } while (false)
  return _continue;
}